SystemOrganization addCategory: #'SqSave-Apps'!
SystemOrganization addCategory: #'SqSave-Base'!
SystemOrganization addCategory: #'SqSave-Tests'!
SystemOrganization addCategory: #'SqSave-Connection'!

!JdmConnection methodsFor: '*sqsave' stamp: 'tk 7/18/2008 16:02'!
socket
	^socket! !

!String methodsFor: '*sqsave' stamp: 'tk 5/15/2008 15:45'!
asDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('description',selector) asSymbol.! !

!String methodsFor: '*sqsave' stamp: 'tk 6/19/2008 15:30'!
asSqSaveDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('persistenceDescription',selector) asSymbol.! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
asSqSaveTableName
	| |
	^self decamelized,'s'! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
decamelized
	| result nextChar |
	result := WriteStream on: String new.
	self withIndexDo: [:char :index |
		nextChar := self at: (index + 1) ifAbsent: [$t].
		(((nextChar isLowercase) and: [char isUppercase]) and:[index > 1]) ifTrue: [
			result nextPutAll: '_'.
		].
		result nextPutAll: char asLowercase asString.
	].
	^result contents! !

!String methodsFor: '*sqsave' stamp: 'tk 5/20/2008 16:46'!
magritteDescriptionClass
	^#MAStringDescription! !

!String methodsFor: '*sqsave' stamp: 'tk 5/20/2008 16:50'!
magritteDescriptionDefaultValue
	^''''''! !

ProtoObject subclass: #SqSProxy
	instanceVariableNames: 'proxiedObject proxyOwner proxiedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqSProxy subclass: #SqSCollectionProxy
	instanceVariableNames: 'collectionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/29/2008 17:16'!
getCollectionChanges
	| counter changes newCollectionMap |
	counter := 0.
	newCollectionMap := self sqSaveCreateCollectionMap.
	changes := Dictionary newFrom: {#added->OrderedCollection new. #deleted->OrderedCollection new. #moved->OrderedCollection new}.
	
	collectionMap ifNil: [^changes].
	collectionMap do: [:oid |
		| newOid |
		counter := counter + 1.
		(counter > newCollectionMap size) ifTrue: [
			(changes at: #deleted) add: (OrderedCollection with: oid with: counter) 
		] ifFalse: [
			newOid := newCollectionMap at: counter.
			(newOid ~= oid) ifTrue: [
				(changes at: #moved) add: (OrderedCollection with: newOid with: counter) 		
			]
		]				
	].
	[counter < newCollectionMap size] whileTrue: [
		counter := counter + 1.
		(changes at: #added) add: (OrderedCollection with: (newCollectionMap at: counter) with: counter).
	].
	collectionMap := newCollectionMap.
	^changes! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 10:48'!
proxiedObject: anObject 
	super proxiedObject: anObject.
	"only update the map when there is not already one present"
	collectionMap ifNil: [ collectionMap := self sqSaveCreateCollectionMap ]! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:09'!
sqSaveClass
	^ self proxiedObject class! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 9/5/2008 15:23'!
sqSaveCreateCollectionMap
	| tmpMap |
	proxiedObject
		ifNotNil: [tmpMap := OrderedCollection new.
			proxiedObject
				do: [:obj | tmpMap
						add: (obj
								ifNotNil: [obj oid])]].
	^ tmpMap! !

!SqSProxy class methodsFor: 'as yet unclassified' stamp: 'tk 9/1/2008 10:50'!
for: aCollection ofInstVar: anIvarName in: anObject 
	^ self new
		proxyOwner: anObject;
		proxiedObject: aCollection;
		proxiedVariable: anIvarName! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 9/15/2008 17:30'!
doesNotUnderstand: aMessage 
	"TODO: handling for fancy load strategies here"
	self proxiedObject ifNil: 
		[ self proxiedObject: ((SqSBase for: self proxyOwner) loadProxiedObjectOfVariable: self proxiedVariable) ].
	"TODO: implement some sort of access loggin here"
	^ aMessage sendTo: self proxiedObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 10:49'!
proxiedObject
	^ proxiedObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 10:49'!
proxiedObject: anObject
	proxiedObject := anObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxiedVariable
	^ proxiedVariable! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxiedVariable: anObject
	proxiedVariable := anObject.! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxyOwner
	^ proxyOwner! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxyOwner: anObject
	proxyOwner := anObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
sqSaveClass
	^ self proxiedObject class! !

!Collection methodsFor: '*sqsave' stamp: 'tk 7/14/2008 19:02'!
join: joinString
	| joiner |
	joiner := joinString ifNil:[''] ifNotNil: [joinString].
	^String streamContents: [:s | self asStringOn: s delimiter: joiner]! !

TestCase subclass: #SqSaveBaseTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:47'!
clearDatabase
	connection resetDatabase! !

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/4/2008 17:36'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveBaseTest methodsFor: 'private' stamp: 'tkow 9/9/2008 10:36'!
setUp
	SqSConnectionManager getInstance setupTestConnection.
	connection := SqSConnectionManager getInstance connectionForCategory: SqSConnectionManager testCategory! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 11:18'!
testGetDirectlyReferencedObjects
	| testObject testObject2 directlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testInteger: 4.
	testObject testSomething: testObject2.
	base := SqSBase for: testObject.
	base descriptionHandler createDescriptionMethods.
	directlyReferencedObjects := base directlyReferencedObjects.
	self assert: directlyReferencedObjects size == 1.
	self assert: directlyReferencedObjects first == testObject2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 10:38'!
testGetIndirectlyReferencedObjects
	| testObject testObject2 indirectlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testInteger: 4.
	testObject
		testSomething: (OrderedCollection with: testObject2).
	base := SqSBase for: testObject.
	base descriptionHandler createDescriptionMethods.
	indirectlyReferencedObjects := base indirectlyReferencedObjects.
	self assert: indirectlyReferencedObjects size == 1.
	self assert: (indirectlyReferencedObjects first at: #collection) first == testObject2.
	self assert: (indirectlyReferencedObjects first at: #description) class = SqSCollectionDescription! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 10:41'!
testGetPersistedInstanceVariables
	| testObject1 testObject2 |
	testObject1 := SqSBase for: SqSaveTestObject new.
	testObject2 := SqSBase for: SqSaveTestObjectChild new.

	self assert: testObject1 persistedInstVars size = 4.
	self assert: testObject1 persistedInstVars size < testObject2 persistedInstVars size.
	self assert: (testObject2 persistedInstVars includes: 'testUnstoredVariable') not.
	self assert: (testObject2 persistedInstVars includes: 'oid') not! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/8/2008 18:48'!
testNewRecordAttribute
	| obj obj2 oid |
	self clearDatabase.
	SqSBase flushOidCacheFor: SqSaveTestObject.
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	self assert: (SqSBase oidFor: obj) isNil.
	obj save.
	self assert: (SqSBase oidFor: obj) isNil not.
	oid := SqSBase oidFor: obj.
	self assert: ((SqSBase cachedObjectOfClass: SqSaveTestObject withOid: oid) == obj).
	obj2 := SqSaveTestObject findByTestInteger: 42.
	self assert: (SqSBase oidFor: obj2) isNil not! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testObjectIdAssignment
	| testObject testObject2 |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: testObject oid == 1.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 4.
	testObject2 save.
	self assert: testObject2 oid == 2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:19'!
testPersistenceDescriptorCreationOnSave
	| testObject description |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject
		testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: SqSaveTestObject new.
	testObject save.
	description := SqSaveTestObject persistenceDescriptionTestInteger.
	self assert: description class = SqSColumnDescription.
	self assert: description sqlType = 'SMALLINT'.
	self assert: description columnName = 'test_integer'.
	self assert: description associatedClass isNil.
	self assert: description tableName = SqSaveTestObject name asSqSaveTableName! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:19'!
testPersistenceDescriptorCreationOnSaveHappensOnlyInTheClassesDefiningTheVariable
	| testObject |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject testSubString: 'test'.
	testObject testExtremelyDeepSubString: 'test'. 
	testObject save.
	self assert: (SqSaveTestObject class includesSelector: 'testDate' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testInteger' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSomething' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObjectChild class includesSelector: 'testSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObjectEvenDeeperChild class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSubString' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObject class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector) not.
	
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 11:30'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.

	self assert: ((SqSBase for: testObject) tableForClassExists not).

	testObject save.
	self assert: ((SqSBase for: testObject) tableForClassExists).! !

TestCase subclass: #SqSaveCollectionTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tk 8/25/2008 17:47'!
clearDatabase
	connection resetDatabase! !

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tk 8/25/2008 10:40'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tkow 9/9/2008 10:36'!
setUp
	SqSConnectionManager getInstance setupTestConnection.
	connection := SqSConnectionManager getInstance connectionForCategory: SqSConnectionManager testCategory! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/29/2008 17:05'!
testCollectionAdding
	| testObject2 testObject1 testResult testObject3 testResult2 |
	self removeDescriptions.
	self clearDatabase.	
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.

	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
		
	testObject1 save.
	
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult isNil not).
	self assert: (testResult testSomething isCollection).
	self assert: ((testResult testSomething at: 1) = testObject2).
	
	testObject3 := SqSaveTestObject new
		testInteger: 42;
		yourself.
 
	testResult testSomething add: testObject3.
	testResult save.
	
	testResult2 := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult2 isNil not).
	self assert: (testResult2 testSomething isCollection).
	self assert: ((testResult2 testSomething at: 1) = testObject2).
	self shouldnt: [testResult2 testSomething at: 2] raise: Error.
	self assert: (testResult2 testSomething at: 2) = testObject3.
	
! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 9/8/2008 11:11'!
testCollectionRemoving
	| testObject2 testObject1 testResult testObject3 |
	self removeDescriptions.
	self clearDatabase.
	testObject2 := SqSaveTestObject new testInteger: 42;
				 yourself.
	testObject1 := SqSaveTestObject new testInteger: 21;
				
				testSomething: (OrderedCollection with: testObject2);
				 yourself.
	testObject3 := SqSaveTestObject new testInteger: 42;
				 yourself.
	testObject1 testSomething add: testObject3.
	testObject1 save.
	testObject1 testSomething removeAt: 2.
	testObject1 save.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1)
			= testObject2.
	self
		should: [testResult testSomething at: 2]
		raise: Error! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/29/2008 17:17'!
testCollectionShuffling
	| testObject2 testObject1 testResult testObject3 |
	self removeDescriptions.
	self clearDatabase.
	testObject2 := SqSaveTestObject new testInteger: 42.
	testObject1 := SqSaveTestObject new testInteger: 21;
				testSomething: (OrderedCollection with: testObject2).
	testObject3 := SqSaveTestObject new testInteger: 42.
	
	testObject1 testSomething add: testObject3.
	testObject1 save.
	testObject1 testSomething: testObject1 testSomething reversed.
	testObject1 save.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1)
			= testObject3.
	self assert: (testResult testSomething at: 2)
			= testObject2! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 9/15/2008 17:33'!
testCollectionWithSimpleValues
	| testCollection testObject testResult |
	self clearDatabase.
	self removeDescriptions.
	testCollection := Set
				with: 42
				with: 21
				with: 84.
	testObject := SqSaveTestObject new testInteger: 42;
				 testString: 'fortyTwo';
				 testSomething: testCollection.
	testObject save.
	testObject := nil.
	SqSBase flushOidCache.
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self
		assert: (testResult testSomething includes: 21).
	self
		assert: (testResult testSomething includes: 42).
	self
		assert: (testResult testSomething includes: 84)! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 10:26'!
testDescriptionCreation
	| testObject testObject2 description referenceColumn ownerColumn base |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	
	base := SqSBase for: testObject.
	base descriptionHandler createDescriptionMethods.
	
	self shouldnt: [description := SqSaveTestObjectEvenDeeperChild persistenceDescriptionTestSomething] raise: Error.
	self assert: description isNil not.
	self assert: description describesCollection.
	self assert: description joinTableName = 'sq_save_test_objects_test_something'.
	referenceColumn := description referenceColumn.
	self assert: referenceColumn columnName = 'test_something_id'.
	self assert: description referenceTableName = 'sq_save_test_objects'.
	ownerColumn := description ownerColumn.
	self assert: ownerColumn columnName = 'sq_save_test_object_id'.! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 9/15/2008 16:38'!
testNilObjectsInCollections
	| testObject2 testObject1 testResult testObject3 |
	self removeDescriptions.
	self clearDatabase.
	testObject2 := SqSaveTestObject new testInteger: 42;
				 yourself.
	testObject1 := SqSaveTestObject new testInteger: 21;
				
				testSomething: (OrderedCollection with: testObject2);
				 yourself.
	testObject3 := SqSaveTestObject new testInteger: 42;
				 yourself.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: testObject3.
	testObject1 testSomething add: nil.

	testObject1 save.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1)
			= testObject2.
	self
		shouldnt: [testResult testSomething at: 2]
		raise: Error.
	self assert: testResult testSomething size = 5.
	self assert: (testResult testSomething at: 2) isNil! !

TestCase subclass: #SqSaveColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveColumnTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:19'!
testCreationCode
	| column column2 |
	column := SqSColumnDescription new.
	column columnName: 'testColumn'.
	column sqlType: 'INTEGER'.
	column2 := Compiler evaluate: column creationCode.
	self assert: column2 class = SqSColumnDescription.
	self assert: column2 sqlType = 'INTEGER'.
	self assert: column2 columnName = 'testColumn'! !

TestCase subclass: #SqSaveConnectionManagerTest
	instanceVariableNames: 'connectionManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveConnectionManagerTest methodsFor: 'running' stamp: 'tkow 9/2/2008 16:23'!
setUp
	connectionManager := SqSConnectionManager getInstance! !

!SqSaveConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 10:36'!
testAddConnectionSpecification
	| connectionSpecification connection |
	connectionManager connectionSpecificationDictionary: Dictionary new.
	connectionSpecification := SqSConnectionSpecification 
		user: 'thomas'
		password: 'test'
		port: 3306
		database: 'squeak_test'
		hostname: 'localhost'
		driver: #SqSMySQLDriver.
	connectionManager 
		setupConnectionSpecification: connectionSpecification
		for: 'TKSave'.
	self assert: (connectionManager connectionSpecificationDictionary includesKey: 'TKSave').
	self assert: (connectionManager connectionSpecificationDictionary at: 'TKSave') class == SqSConnectionSpecification.
	connection := connectionManager connectionForCategory: 'TKSave'.
	self assert: connection isNil not! !

TestCase subclass: #SqSaveDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 9/15/2008 14:41'!
testCollectionCheck
	| collection descriptionHandler |
	"a collection with simple values"
	collection := OrderedCollection 
		with: 1
		with: 2
		with: 3.
	descriptionHandler := SqSDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.
	
	"a collection with simple values and nil"
	collection add: nil.
	descriptionHandler := SqSDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.
	
	"a collection with values from completely different classes"
	collection add: 'test'.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
		
	"a collection with complex values"
	collection := OrderedCollection 
		with: (SqSaveTestObject new) 
		with: (SqSaveTestObjectChild new).
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).	
	
	"a collection with complex values and nil values"
	collection add: nil.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).	

	"a collection with complex values and simple values"
	collection add: 42.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.			
! !

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 17:36'!
testSqlTypeRecognition
	| handler |
	handler := (SqSBase for: SqSaveTestObject new) descriptionHandler.
	self assert: (handler sqlTypeForObject: 42)
			= 'SMALLINT'.
	self assert: (handler sqlTypeForObject: 42)
			= 'SMALLINT'.
	self assert: (handler sqlTypeForObject: SqSaveTestObject new)
			= 'INTEGER'.
	self assert: (handler sqlTypeForObject: true)
			= 'BOOLEAN'! !

TestCase subclass: #SqSaveDictionaryExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveDictionaryExtensionTests methodsFor: 'tests' stamp: 'tk 8/15/2008 14:49'!
testValueJoin
	| dict1 dict2 result |
	dict1 := Dictionary new.
	dict1 at: #test1 put: (OrderedCollection with: 42).
	dict1 at: #test2 put: 42.
	dict1 at: #test3 put: (OrderedCollection with: 84).
	
	dict2 := Dictionary new.
	dict2 at: #test1 put: (OrderedCollection with: 21).
	dict2 at: #test2 put: 21.
	
	result := dict1 valueJoin: dict2.
	self assert: ((result at: #test1) isCollection).
	self assert: ((result at: #test1) includes: (42)).
	self assert: ((result at: #test1) includes: (21)).

	self assert: ((result at: #test2) isCollection).
	self assert: ((result at: #test2) includes: (42)).
	self assert: ((result at: #test2) includes: (21)).

	self assert: ((result at: #test3) isCollection).
	self assert: ((result at: #test3) includes: (84)).
	! !

TestCase subclass: #SqSaveInheritanceTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqSaveInheritanceTest subclass: #SqSaveClassTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 9/10/2008 16:21'!
setUp
	| code |
	super setUp.
	code := (SqSSimpleDescriptionHandler inheritanceModeFunction),String cr,String tab, '^#',(SqSTableStructureHandler classTableInheritance).
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 15:52'!
testCascadingDelete
	| dbConnection result testObject resultDicts oid |
	testObject := SqSaveTestObjectEvenDeeperChild new
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	(SqSBase for: testObject).
	oid := testObject oid.
	testObject destroy.
	dbConnection := SqSConnectionManager getInstance connectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectChild name asSqSaveTableName , ' WHERE oid = ' , oid asString.
	resultDicts := OrderedCollection new.
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary ].
	self assert: resultDicts isEmpty.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectEvenDeeperChild name asSqSaveTableName , ' WHERE oid = ' , oid asString.
	resultDicts := OrderedCollection new.
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary ].
	self assert: resultDicts isEmpty! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 18:03'!
testGetClassTableColumns
	self assert: (SqSBase for: SqSaveTestObject new) allClassTableColumns keys size = 5.
	self assert: (SqSBase for: SqSaveTestObjectChild new) allClassTableColumns keys size = 1.
	self assert: (SqSBase for: SqSaveTestObjectEvenDeeperChild new) allClassTableColumns keys size = 1! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 17:41'!
testTableNames
	self assert: (SqSBase for: SqSaveTestObject new) tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: (SqSBase for: SqSaveTestObjectChild new) tableName = SqSaveTestObjectChild name asSqSaveTableName.
	self assert:(SqSBase for: SqSaveTestObjectEvenDeeperChild new)  tableName = SqSaveTestObjectEvenDeeperChild name asSqSaveTableName! !

!SqSaveInheritanceTest class methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:08'!
shouldInheritSelectors
	^true! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:48'!
clearDatabase
	connection resetDatabase! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 6/26/2008 18:05'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 8/12/2008 13:41'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveInheritanceTest methodsFor: 'running' stamp: 'tkow 9/9/2008 10:36'!
setUp
	connection := SqSConnectionManager getInstance connectionForCategory: 'TKSave'.
	self clearDatabase.
	self removeDescriptions! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 11:21'!
testComplexCollectionStorage
	| testObject testObject2 testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject
		testSomething: (OrderedCollection with: testObject2).
	testObject testInteger: 42.
	testObject save.
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testObject = testResult.
	"we still are ahold of the object, thus no proxy will be created"
	self assert: testResult testSomething class = OrderedCollection.
	self assert: testResult testSomething first = testObject2! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testCorrectObjectCreation
	| testObject1 testObject2 result |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	result := SqSaveTestObject findByTestInteger: 42.
	self assert: result class = SqSaveTestObject.
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save.
	result := SqSaveTestObject findByTestInteger: 21.
	self assert: result class = SqSaveTestObjectChild! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testDestroyObjects
	| testObject searchResult newSearchResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	searchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (searchResult isNil not).
	searchResult destroy.
	newSearchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (newSearchResult isNil).! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 17:40'!
testGetPersistedInstanceVariables
	| ivars1 ivars2 ivars3 |
	ivars1 := (SqSBase for: SqSaveTestObject new) persistedInstVars.
	ivars2 := (SqSBase for: SqSaveTestObjectChild new) persistedInstVars.
	ivars3 := (SqSBase for: SqSaveTestObjectEvenDeeperChild new) persistedInstVars.
	self assert: ivars1 size = 4.
	self assert: ivars2 size = 5.
	self assert: ivars3 size = 6.
	self assert: (ivars3 includes: 'testUnstoredVariable') not.
	self assert: (ivars3 includes: 'oid') not! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:45'!
testNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	searchResult0 := SqSaveTestObject 
		findByTestInteger: 5
		andTestDate: Date today.
	searchResult1 := SqSaveTestObject findByTestInteger: 5.
	searchResult2 := SqSaveTestObject 
		findByTestDate: Date today
		andTestString: 'test'.
	searchResult3 := SqSaveTestObject findByTestString: 'test'.
	self assert: searchResult0 isNil not.
	self assert: searchResult0 testInteger = 5.
	self assert: searchResult0 testDate = Date today.
	self assert: searchResult0 testString = 'test'.
	self assert: testObject = searchResult1.
	self assert: testObject = searchResult2.
	self assert: testObject = searchResult3! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testObjectCompleteness
	| testObject testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testSubString: 'twentyOne';
		testExtremelyDeepSubString: 'elevenAndAHalf'.
	testObject save.
	testResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (testResult isNil not).
	self assert: (testResult testInteger =  42).
	self assert: (testResult testString = 'fortyTwo').
	self assert: (testResult testDate = Date today).
	self assert: (testResult testSomething = 3).
	self assert: (testResult testSubString = 'twentyOne').
	self assert: (testResult testExtremelyDeepSubString = 'elevenAndAHalf').

	! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 17:21'!
testSaveRelatedObjectAlongWithObject
	| testObject testObject2 result base |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	
	base := SqSBase for: testObject2.
	self assert: base newRecord.
	testObject save.
	self assert: base newRecord not.
	self assert: base oid isNil not.
	result := SqSaveTestObject findByTestInteger: 6.
	self assert: result == testObject2! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/1/2008 13:07'!
testSomething
	self assert: true.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:45'!
testUpdate
	| testObject testResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 3.14;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'deepSubString'.
	testObject save.
		
	testObject testString: 'newTest'.
	testObject save.
	
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: (testResult testString = 'newTest').! !

SqSaveInheritanceTest subclass: #SqSaveSingleTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveSingleTableInheritanceTest methodsFor: 'running' stamp: 'tkow 9/10/2008 17:51'!
setUp
	| code |
	super setUp.
	code := (SqSSimpleDescriptionHandler inheritanceModeFunction),String cr,String tab, '^#',(SqSTableStructureHandler singleTableInheritance).
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 18:04'!
testGetClassTableColumns
	self assert: (SqSBase for: SqSaveTestObject new) allClassTableColumns keys size = 5.
	self assert: (SqSBase for: SqSaveTestObjectChild new) allClassTableColumns keys size = 6.
	self assert: (SqSBase for: SqSaveTestObjectEvenDeeperChild new) allClassTableColumns keys size = 7! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 17:50'!
testSaveSubclassWithSingleTableInheritance
	| testObject base |
	
	base := SqSBase for: SqSaveTestObjectChild new.
	
	self assert: base tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: base tableForClassExists not.
	testObject := SqSaveTestObjectChild new.
	testObject testSubString: 'Subtest'.
	testObject save.
	self assert: base tableForClassExists! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/9/2008 10:36'!
testTypeParameter
	| testObject1 testObject2 dbConnection result resultDict |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	dbConnection := SqSConnectionManager getInstance connectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObject name asSqSaveTableName , ' WHERE test_integer = 42'.
	[ result next ] whileTrue: 
		[ resultDict := result currentRowAsDictionary.
		self assert: (resultDict at: dbConnection class inheritanceTypeField) = SqSaveTestObject name asString ].
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save! !

TestCase subclass: #SqSaveMagritteDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'running' stamp: 'tk 6/26/2008 17:53'!
setUp
	SqSaveTestObject instVarNames do: 
		[ :ivn | 
		(SqSaveTestObject class includesSelector: ivn asDescriptionSelector) ifTrue: [ SqSaveTestObject class removeSelector: ivn asDescriptionSelector ].
		(SqSaveTestObject class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ SqSaveTestObject class removeSelector: ivn asSqSaveDescriptionSelector ] ]! !

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'tests' stamp: 'tk 8/31/2008 15:23'!
testCreateDescriptionMethods
	| obj |
	"self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not.
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	obj testString: 'test'.
	obj testDate: Date today.
	(SqSaveSimpleDescriptionHandler for: obj) createDescriptionMethods.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not"! !

TestCase subclass: #SqSaveStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 5/15/2008 15:46'!
testAsDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/19/2008 15:34'!
testAsSqSaveDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/24/2008 15:33'!
testAsSqSaveTableName
	| testString |
	testString := 'TKSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'tk_save_test_objects').
	testString := 'SqSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'sq_save_test_objects').
	testString := 'SqSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'sqsave_test_objects').
	testString := 'TKSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'tksave_test_objects').
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/14/2008 17:45'!
testCollectionJoin
	self assert: ((#('hallo' 'welt') join: '-') = 'hallo-welt').
	self assert: ((#('hallo' 'welt') join: '') = 'hallowelt').
	self assert: ((#('hallo' 'welt') join: nil) = 'hallowelt')! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/7/2008 16:48'!
testDecamelized
	self assert: 'sq_save_type_field' decamelized = 'sq_save_type_field'.
	self assert: 'SqSaveTypeField' decamelized = 'sq_save_type_field'.! !

TestCase subclass: #SqSaveTableStructureHandlerTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqSaveTableStructureHandlerTest subclass: #SqSaveClassTableInheritanceStructureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveClassTableInheritanceStructureTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 15:41'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #classTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		 testInteger: 42;
		 testDate: Date today;
		 testSomething: 4.5243;
		 testSubString: 'FortyTwo';
		 testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.

	self assert: ((SqSBase for: (SqSaveTestObject new)) tableForClassExists).
	self assert: ((SqSBase for: (SqSaveTestObjectChild new)) tableForClassExists).
	self assert: ((SqSBase for: (SqSaveTestObjectEvenDeeperChild new)) tableForClassExists).! !

SqSaveTableStructureHandlerTest subclass: #SqSaveSingleTableInheritanceStructureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveSingleTableInheritanceStructureTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 15:49'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		 testInteger: 42;
		 testDate: Date today;
		 testSomething: 4.524;
		 testSubString: 'FortyTwo';
		 testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: ((SqSBase for: testObject) tableForClassExists).! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:49'!
clearDatabase
	connection resetDatabase! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/8/2008 15:26'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tkow 9/10/2008 17:48'!
setTestObjectInheritanceModeTo: aSymbolString
	| code |
	code := (SqSSimpleDescriptionHandler inheritanceModeFunction),String cr,String tab, '^#',aSymbolString.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveTableStructureHandlerTest methodsFor: 'running' stamp: 'tkow 9/9/2008 10:36'!
setUp
	connection := SqSConnectionManager getInstance connectionForCategory: 'TKSave'! !

!SqSaveTableStructureHandlerTest methodsFor: 'tests' stamp: 'tkow 9/10/2008 17:49'!
testCorrectClassChoosing
	| sampleObject |
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler singleTableInheritance.
	sampleObject := SqSBase for: SqSaveTestObject new.
	self assert: (SqSTableStructureHandler for: sampleObject) class = SqSSingleTableInheritanceTableStructureHandler.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler classTableInheritance.
	sampleObject := SqSBase for: SqSaveTestObject new.
	self assert: (SqSTableStructureHandler for: sampleObject) class = SqSClassTableInheritanceTableStructureHandler! !

!Object methodsFor: '*sqsave' stamp: 'tkow 9/10/2008 15:42'!
destroy
	(SqSBase for: self) destroy! !

!Object methodsFor: '*sqsave' stamp: 'tkow 9/5/2008 15:49'!
oid
	^SqSBase oidFor: self! !

!Object methodsFor: '*sqsave' stamp: 'tkow 9/3/2008 17:11'!
save
	(SqSBase for: self) save! !

!Object methodsFor: '*sqsave' stamp: 'tk 8/26/2008 16:43'!
sqSaveClass
	^self class! !

Object subclass: #SqSBase
	instanceVariableNames: 'sqsConnection sqsObject sqsTableName sqsDescriptionHandler sqsStructureHandler oid'
	classVariableNames: 'ObjectCache ObjectIdCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 17:35'!
cacheObject: anObject withOid: oid
	(self objectCacheFor: anObject class) at: oid put: anObject.
	(self objectIdCacheFor: anObject class) at: anObject put: oid.! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/8/2008 18:33'!
cachedObjectOfClass: aClass withOid: oid
	^(self objectCacheFor: aClass) 
		at: oid 
		ifAbsent: [
			(self objectCacheFor: aClass) removeUnreferencedKeys.
			nil
		]! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/8/2008 11:24'!
flushOidCache
	ObjectIdCache := nil.! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/8/2008 11:26'!
flushOidCacheFor: aClass
	ObjectIdCache ifNil: [
		ObjectIdCache := Dictionary new	
	].
	ObjectIdCache at: aClass name put: WeakIdentityKeyDictionary new.! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:06'!
for: anObject
	^(self new)
		sqsObject: anObject;
		yourself! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/8/2008 18:18'!
objectCacheFor: aClass
	ObjectCache ifNil: [
		ObjectCache := Dictionary new.	
	].
	ObjectCache at: aClass name ifAbsentPut: [
		WeakValueDictionary new.	
	].
	^ObjectCache at: aClass name! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/5/2008 15:54'!
objectIdCacheFor: aClass
	ObjectIdCache ifNil: [
		ObjectIdCache := Dictionary new.	
	].
	ObjectIdCache at: aClass name ifAbsentPut: [
		WeakIdentityKeyDictionary new.	
	].
	^ObjectIdCache at: aClass name! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/5/2008 15:54'!
oidFor: anObject
	^(self objectIdCacheFor: anObject class) at: anObject ifAbsent: [nil]! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:47'!
uncacheObject: anObject withOid: anOid
	(self objectIdCacheFor: anObject class) removeKey: anOid.
	(self objectCacheFor: anObject class) removeKey: anObject.! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/20/2008 14:14'!
useInstVarAccessors
	^false! !

!SqSBase methodsFor: 'nil' stamp: 'tk 7/15/2008 15:10'!
= anObject
	(anObject isKindOf: (self class)) ifFalse:[
		^false.
	].
	^anObject oid = self oid.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:19'!
allClassTableColumns
	^ self descriptionHandler allClassTableColumns! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:28'!
asSqlValueString
	^(self oid) asSqlValueString! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:48'!
baseClass
	| klass |
	klass := self sqsObject class.
	[(klass superclass = Object) or: [klass superclass = SqSUtil]] whileFalse: [
		klass := klass superclass
	].
	^klass! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/8/2008 18:37'!
columnNameForInstVar: ivn
	^ivn decamelized! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:22'!
createClassDescription
	^self descriptionHandler createDescriptionMethods.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:07'!
createClassDescriptionFor: aSampleObject
	^(self descriptionHandler for: aSampleObject) createDescriptionMethods.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 18:23'!
createRecord
	self tableStructureHandler insertObject.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:54'!
descriptionHandler
	sqsDescriptionHandler ifNil: [
		sqsDescriptionHandler := SqSSimpleDescriptionHandler for: self
	].
	^sqsDescriptionHandler
	! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:44'!
destroy
	self oid ifNotNil: [ 
		(SqSTableStructureHandler for: self) deleteObject 
	].
	! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:09'!
directlyReferencedObjects
	^self descriptionHandler directlyReferencedObjects! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 17:55'!
doForAllSuperclasses: aBlock
	| currentClass baseClass |
	currentClass := self sqsObject class.
	baseClass := self baseClass.
	[currentClass = baseClass superclass] whileFalse: [
		aBlock value: currentClass.
		currentClass := currentClass superclass.
	].! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:36'!
escapedValueForInstVar: instVarName
	| ivarValue |
	"return the class name for the inheritance type field"
	(instVarName = self sqSaveConnection class inheritanceTypeField) ifTrue: [ 
		^ self sqsObject class name asSqlValueString 
	].

	" get the current value of the instance variable"
	ivarValue := self valueOfInstVar: instVarName.
	
	" if an object has an asSqlValueString method, fine - use this
	 the other objects are treated as complex ones and we should already have an oid for them"
	^(ivarValue respondsTo: #asSqlValueString) 
		ifTrue: [ ivarValue asSqlValueString ]
		ifFalse: [ self class oidFor: ivarValue]
		! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:13'!
hash
	^self oid ifNil: [0] ifNotNil: [self oid]! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:34'!
indirectlyReferencedObjects
	^self descriptionHandler indirectlyReferencedObjects! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 11:10'!
instVarsForClassTable
	^self tableStructureHandler instVarsForClassTable! !

!SqSBase methodsFor: 'accessing' stamp: 'tk 6/16/2008 13:35'!
isDirty
	"TODO: enhance me with some sort of check to determine whether an object needs restoring"
	^self newRecord! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:16'!
lazilyInitializedVariables
	^#()! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 17:30'!
loadProxiedObjectOfVariable: ivarName
	^self tableStructureHandler loadProxiedObjectOfVariable: ivarName! !

!SqSBase methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 17:12'!
oid
	oid ifNil: [
		oid := self class oidFor: self sqsObject.
	].
	^oid! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 17:36'!
oid: anInteger
	oid := anInteger.
	self class cacheObject: self sqsObject withOid: oid.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:32'!
persistedInstVars
	| |
	^self descriptionHandler persistedInstanceVariables
	! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:25'!
persistenceInheritanceMode
	^#singleTableInheritance! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:10'!
save
	self createClassDescription.
	self tableForClassExists
		ifTrue: [self tableStructureHandler updateTableStructure]
		ifFalse: [self tableStructureHandler createTableStructure].
	self newRecord
		ifTrue: [self createRecord]
		ifFalse: [self updateRecord]! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 16:19'!
setInstVarNamed: ivarName withValue: anObject 
	"only set instvars of ourselves and ignore those of subclasses"
	| object lazy |
	(self sqsObject class allInstVarNames includes: ivarName)
		ifTrue: [lazy := false.
			"self lazilyInitializedVariables includes: ivarName."
			object := self descriptionHandler
						adaptObject: anObject
						toSpecificationOfInstVar: ivarName
						andDoItLaziliy: lazy.
			self class useInstVarAccessors
				ifTrue: [self sqsObject perform: (ivarName , ':') asSymbol with: object]
				ifFalse: [self sqsObject instVarNamed: ivarName put: object]]! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:04'!
sqSaveConnection
	sqsConnection ifNil: [
		sqsConnection := SqSConnectionManager getInstance connectionForClass: (self sqsObject class)
	].
	^sqsConnection! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:01'!
sqSaveConnection: aConnection
	sqsConnection := aConnection! !

!SqSBase methodsFor: 'accessing' stamp: 'tkow 9/3/2008 17:04'!
sqsObject
	^ sqsObject! !

!SqSBase methodsFor: 'accessing' stamp: 'tkow 9/3/2008 17:04'!
sqsObject: anObject
	sqsObject := anObject! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:09'!
tableForClassExists
	^ self sqSaveConnection checkTableExistance: self tableName! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 17:05'!
tableName
	| klass |
	sqsTableName
		ifNil: [self descriptionHandler inheritanceMode = SqSTableStructureHandler singleTableInheritance
				ifTrue: [klass := sqsObject class.
					[klass superclass = self baseClass superclass]
						whileFalse: [klass := klass superclass].
					sqsTableName := klass name asSqSaveTableName asEscapedSql]
				ifFalse: [sqsTableName := self sqsObject class name asSqSaveTableName asEscapedSql]].
	^ sqsTableName! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:27'!
tableNameForClass: aClass
	"only use me for classes you are sure of using the same description handler 
	 than the one the current sqsObject is using"
	^self descriptionHandler tableNameForClass: aClass
	! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:22'!
tableStructureHandler
	sqsStructureHandler ifNil: [
		sqsStructureHandler := SqSTableStructureHandler for: self	
	].
	^sqsStructureHandler! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 11:13'!
unpersistedInstVars
	| |
	^self descriptionHandler unpersistedInstVars
	! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/17/2008 15:46'!
updateRecord
	self tableStructureHandler updateObject
	! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:31'!
valueOfInstVar: instVarName 
	^self descriptionHandler useInstVarAccessors 
		ifTrue: [ self sqsObject perform: instVarName asSymbol ]
		ifFalse: [ self sqsObject instVarNamed: instVarName asSymbol ].
! !

Object subclass: #SqSConnectionManager
	instanceVariableNames: 'connectionSpecificationDictionary connectionPool defaultConnectionSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

SqSConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

SqSConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:35'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:43'!
testCategory
	^'SqSave'! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/12/2008 13:40'!
clearConnections
	self connectionPool valuesDo: [:connectionQueue |
		connectionQueue do: [ :sqSaveConnection |
			[sqSaveConnection close	] on: Error do: []
		]	
	].
	self connectionPool: Dictionary new.! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/12/2008 18:32'!
connectionForCategory: aCategoryName 
	| cSpec |
	cSpec := self connectionSpecificationDictionary 
		at: aCategoryName
		ifAbsent: nil.
	cSpec ifNil: [
		self defaultConnectionSpec ifNil: [
			self error: 'Please set up at least one connection for storing your data'	
		] ifNotNil: [
			^self connectionFromQueue: self defaultCategory
				for: self defaultConnectionSpec
		].
	] ifNotNil: [ 
		^ self 
			connectionFromQueue: aCategoryName
			for: cSpec 
	].
! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/9/2008 10:36'!
connectionForClass: aClass 
	^ self connectionForCategory: (aClass category subStrings: '-') first! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/9/2008 11:40'!
connectionFromQueue: aCategoryName for: aConnectionSpecification 
	| availableConnections |
	self connectionPool at: aCategoryName ifAbsentPut: (
		OrderedCollection with: (
			(Smalltalk at: aConnectionSpecification driverClass)
				onHost: aConnectionSpecification hostname
				port: aConnectionSpecification port
				withUser: aConnectionSpecification username
				password: aConnectionSpecification password
				database: aConnectionSpecification database)
			).
	availableConnections := self connectionPool at: aCategoryName.		
	^ self pickConnectionFromQueue: availableConnections! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary
	^ connectionSpecificationDictionary! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary: anObject
	connectionSpecificationDictionary := anObject! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/12/2008 18:28'!
defaultCategory
	^#DEFAULT! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/12/2008 18:28'!
defaultConnectionSpec
	^defaultConnectionSpec! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/12/2008 18:35'!
defaultConnectionSpec: aConnectionSpeification
	defaultConnectionSpec := aConnectionSpeification.
! !

!SqSConnectionManager methodsFor: 'initialization' stamp: 'tk 5/5/2008 14:37'!
initialize
	connectionSpecificationDictionary := Dictionary new.
	connectionPool := Dictionary new.! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tk 7/21/2008 14:16'!
pickConnectionFromQueue: aQueue	
	| con |
	con := aQueue first.
	con connectionIsAlive ifFalse: [
		con reconnect
	].
	^con! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 9/12/2008 18:29'!
setupConnectionSpecification: aConnectionSpecification for: aCategoryName
	self connectionSpecificationDictionary at: aCategoryName put: aConnectionSpecification.
	self defaultConnectionSpec ifNil: [
		self defaultConnectionSpec: aConnectionSpecification	
	]! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tkow 9/2/2008 16:24'!
setupTestConnection
	| conSpec |
	conSpec := SqSConnectionSpecification 
		user: 'thomas'
		password: 'test'
		port: 3306
		database: 'squeak_test'
		hostname: 'localhost'
		driver: #SqSMySQLDriver.
	self 
		setupConnectionSpecification: conSpec
		for: self class testCategory! !

Object subclass: #SqSConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 9/9/2008 11:37'!
user: aUsername password: aPassword database: aDatabaseName
	"just for the lazy people like me - creates a mysql connection..."
	^self new
		username: aUsername;
		password: aPassword;
		port: 3306;
		database: aDatabaseName;
		driverClass: #SqSMySQLDriver;
		hostname: 'localhost'.! !

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

Object subclass: #SqSDescriptionHandler
	instanceVariableNames: 'currentObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 16:45'!
collectionValueField
	^'value'! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:04'!
for: aSampleObject 
	^ self new currentObject: aSampleObject! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 14:40'!
sqlValueStringFunction
	^#asSqlValueString! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:11'!
useAdvancedCollections
	^true! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/11/2008 15:54'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean
	^self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 14:22'!
allClassTableColumns
	| variables columnDict columnDescription sqlType |
	variables := self currentObject instVarsForClassTable.
	columnDict := Dictionary new.
	variables
		do: [:var | (self targetClass respondsTo: var asSqSaveDescriptionSelector)
				ifTrue: [columnDescription := self targetClass perform: var asSqSaveDescriptionSelector.
					columnDescription describesCollection
						ifFalse: [columnDict at: var put: columnDescription]]
				ifFalse: [
					sqlType := (var = SqSDriver inheritanceTypeField) ifTrue: [
						self currentObject sqSaveConnection string
					] ifFalse: [
						self currentObject sqSaveConnection smallInteger
					].
					columnDict at: var
						put: (SqSColumnDescription new 
							columnName: var decamelized;
							tableName: self currentObject tableName;
							sqlType: sqlType;
							yourself)]].
	^ columnDict! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 7/14/2008 17:14'!
columnDescriptionFor: ivarName
	self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:13'!
columnNameForInstVar: ivarName
	^ivarName decamelized! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 10:53'!
compileMethodCode: code intoClass: aClass
	(aClass organization categories includes: self descriptorMethodCategory)
		ifTrue: [aClass organization addCategory: self descriptorMethodCategory].
	aClass class compile: code classified: self descriptorMethodCategory! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:14'!
createDescriptionMethods
	"In order to not force everybody to implement the self describing functonality"
	^true! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/2/2008 16:19'!
createProxyFor: ivarName with: anObject 
	(anObject class = SqSProxy or: [ anObject class inheritsFrom: SqSProxy ]) 
		ifTrue: [ ^ anObject ]
		ifFalse: 
			[ ^ SqSProxy 
				for: anObject
				ofInstVar: ivarName
				in: self currentObject ]! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject
	^ currentObject! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject: anObject 
	currentObject := anObject! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:09'!
directlyReferencedObjects
	^self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/5/2008 14:07'!
getIvarValue: ivn 
	| |
	^ self useInstVarAccessors 
		ifTrue: [ self currentObject sqsObject perform: ivn asSymbol ]
		ifFalse: [ self currentObject sqsObject instVarNamed: ivn asSymbol ] 
! !

!SqSDescriptionHandler methodsFor: 'printing' stamp: 'tk 6/19/2008 14:17'!
indent: noOfTabs
	| indent |
	indent := String cr.
	0 to: noOfTabs do: [ :i |
		indent := indent, String tab.
	].
	^indent! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:35'!
indirectlyReferencedObjects
	^self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:08'!
inheritanceMode
	self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 14:40'!
isComplexCollection: aCollection 
	"this check tries to find out whether a collection includes 'simple' objects.
	This is necessary, because collections with simple value don't point to
	another table
	but instead contain the values themselves. Addtionally there is a check
	to find out 
	whether all values of a collection are somehow related to one-another,
	because only
	such values can be stored in a reasonable manner.
	Return value is true or false and tells us whether this collection holds
	complex objects or not"
	| sampleValue complexCollection isDict |
	sampleValue := nil.
	complexCollection := true.
	isDict := aCollection isDictionary.
	aCollection
		do: [:element | 
			| currentValue | 
			currentValue := isDict
						ifTrue: [element value]
						ifFalse: [element].
			currentValue
				ifNotNil: [sampleValue
						ifNil: [sampleValue := currentValue].
					complexCollection := (currentValue respondsTo: self class sqlValueStringFunction) not.
					((currentValue class includesBehavior: sampleValue class)
							or: [sampleValue class inheritsFrom: currentValue class])
						ifFalse: [self error: 'SqueakSave currently only supports collections with values that belong to the same base class (other than object...)']]].
	^ complexCollection! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/9/2008 11:16'!
isComplexObject: anObject
	"determines whether an object is of a primitive type that can be stored
	directly in a database column, or if an additional table is required"
	| connection currentClass isPrimitive |
	connection := self currentObject sqSaveConnection.
	currentClass := anObject class.
	isPrimitive := false.
	[(currentClass superclass = Object) or: [isPrimitive]] whileFalse: [
		isPrimitive := connection respondsTo: (currentClass name withFirstCharacterDownshifted).
		currentClass := currentClass superclass.
	].
	^isPrimitive not! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:33'!
persistedInstanceVariables
	self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/9/2008 11:12'!
sqlTypeForObject: anObject 
	| connection sqlType classResolved currentClass |
	"determines the sql type for an object - this will always return at least 
	INTEGER since every object should be storeable somehow"
	connection := self currentObject sqSaveConnection.
	classResolved := false.
	currentClass := anObject class.
	sqlType := connection integer.
			
	[ classResolved or: [ currentClass = Object ] ] whileFalse: 
		[ (connection respondsTo: currentClass name withFirstCharacterDownshifted) 
			ifTrue: 
				[ sqlType := connection perform: currentClass name withFirstCharacterDownshifted.
				classResolved := true ]
			ifFalse: [ currentClass := currentClass superclass ] ].
	^ sqlType! !

!SqSDescriptionHandler methodsFor: 'printing' stamp: 'tkow 9/3/2008 17:55'!
targetClass
	^self currentObject sqsObject class! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 11:25'!
unpersistedInstVars
	| unpersistedVars currentClass |
	"gather the unpersisted instance variables of all classes within the inheritance chain"
	unpersistedVars := Set new.
	currentClass := self targetClass.
	[currentClass = self currentObject baseClass] whileFalse: [
		unpersistedVars addAll: (self unpersistedInstVarsOf: currentClass).
		currentClass := currentClass superclass.
	].
	^unpersistedVars
	! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:23'!
unpersistedInstVarsOf: klass
	self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/5/2008 14:01'!
useInstVarAccessors
	self subclassResponsibility! !

SqSDescriptionHandler subclass: #SqSSimpleDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSSimpleDescriptionHandler commentStamp: 'tk 6/19/2008 15:22' prior: 0!
A TKSaveMagritteDescriptionHandler is  .

Instance Variables
!

!SqSSimpleDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:54'!
inheritanceModeFunction
	^#tableInheritance! !

!SqSSimpleDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:12'!
tableNameFunction
	^#sqSaveTableName! !

!SqSSimpleDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsFunction
	^#sqSaveUnpersistedInstVars! !

!SqSSimpleDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:14'!
useInstVarAccessorsFunction
	^#useInstVarAccessors! !

!SqSSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/3/2008 17:56'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean 
	| persistenceDescr proxy |
	(self targetClass respondsTo: ivarName asSqSaveDescriptionSelector asSymbol) ifTrue: [ 
		persistenceDescr := self targetClass perform: ivarName asSqSaveDescriptionSelector.
		persistenceDescr associatedClass ifNil: [
			^anObject	
		] ifNotNil: [
			proxy := self createProxyFor: ivarName with: anObject.
			^proxy
		]
	] ifFalse: [ 
		^ nil 
	]! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 17:56'!
columnDescriptionFor: ivarName 
	^ self targetClass perform: ivarName asSqSaveDescriptionSelector! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 14:46'!
createCollectionDescriptionFor: ivn basedOn: aCollection inClass: aClass 
	"only create descriptors for non-empty collections"
	^(aCollection isEmpty) ifTrue: [
		nil
	] ifFalse: [
		self 
			persistenceDescriptionForCollection: aCollection
			withLabel: ivn
			complexValues: (self isComplexCollection: aCollection) 
	].! !

!SqSSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/9/2008 11:10'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass storedInTableNamed: tableName 
	| column sqlType |
	column := SqSColumnDescription new.
	sqlType := self sqlTypeForObject: anObject.
	column
		columnName: aLabel decamelized;
		objectClass: anObject class name asSymbol;
		tableName: tableName;
		sqlType: sqlType.
	aClass ifNotNil: [ column associatedClass: aClass ].
	^ column! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 11:03'!
createDescriptionMethods
	| anObject targetClass |
	self persistedInstanceVariables
		do: [:ivn | 
			anObject := self getIvarValue: ivn.
			targetClass := self findTargetClassForDescriptorOfIvarNamed: ivn.
			anObject
				ifNotNil: [(targetClass respondsTo: ivn asSqSaveDescriptionSelector)
						ifTrue: [self
								updatePersistenceDescriptorFor: ivn
								basedOn: anObject
								inClass: targetClass]
						ifFalse: [self
								writePersistenceDescriptorFor: ivn
								basedOn: anObject
								inClass: targetClass]]]! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/9/2008 11:28'!
createPersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass 
	"ensure that for all collections (except for strings) we create different descriptors"
	^ ((anObject isCollection) and: [ anObject isString not])
		ifTrue: [self
				createCollectionDescriptionFor: ivn
				basedOn: anObject
				inClass: aClass]
		ifFalse: [self
				persistenceDescriptionForObject: anObject
				withLabel: ivn
				storedInTableNamed: (self tableNameForClass: aClass)]! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/31/2008 15:17'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:27'!
directlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables 
		do: [:ivn | (self targetClass respondsTo: ivn asSqSaveDescriptionSelector)
				ifTrue: [descr := self targetClass perform: ivn asSqSaveDescriptionSelector.
					descr associatedClass
						ifNotNil: [ivarValue := self getIvarValue: ivn.
							ivarValue
								ifNotNil: [referencedObjects add: ivarValue]]]].
	^ referencedObjects! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/5/2008 13:57'!
findTargetClassForDescriptorOfIvarNamed: ivn 
	| targetClass baseClass |
	targetClass := self targetClass.
	baseClass := self currentObject baseClass.
	[targetClass ~= baseClass superclass]
		whileTrue: [(targetClass instVarNames includes: ivn)
				ifTrue: [^ targetClass].
			targetClass := targetClass superclass].
	self error: 'instance variable named ' , ivn , ' could not be found in the class hierarchy of ' , self currentObject class name! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:27'!
indirectlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables
		do: [:ivn | (self targetClass respondsTo: ivn asSqSaveDescriptionSelector)
				ifTrue: [descr := self targetClass perform: ivn asSqSaveDescriptionSelector.
					descr describesCollection
						ifTrue: [ivarValue := self getIvarValue: ivn.
							ivarValue
								ifNotNil: [referencedObjects
										add: (Dictionary newFrom: {#collection -> ivarValue. #description -> descr. #variable -> ivn})]]]].
	^ referencedObjects! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:11'!
inheritanceMode
	^(self targetClass respondsTo: self class inheritanceModeFunction) ifTrue: [
		self targetClass perform: (self class inheritanceModeFunction)	
	] ifFalse: [
		SqSTableStructureHandler singleTableInheritance
	]
		! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 15:33'!
ownerColumnForCurrentObject
	^SqSColumnDescription new
		sqlType: self currentObject sqSaveConnection integer;
		columnName: self currentObject baseClass name decamelized , '_id';
		foreignKey: (SqSForeignKeyDescription new
				referencedColumns: (OrderedCollection with: self currentObject sqSaveConnection class objectIdField);
				referencedTable: self currentObject tableName;
				deleteActions: #(#CASCADE ));
		canBeNull: false.! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/5/2008 13:56'!
persistedInstanceVariables
	| klass persistedVars baseClass |
	klass := self targetClass.
	baseClass := self currentObject baseClass.
	persistedVars := Set new.
	[klass = baseClass superclass]
		whileFalse: [persistedVars addAll: klass instVarNames.
			persistedVars := persistedVars
						difference: (self unpersistedInstVarsOf: klass).
			klass := klass superclass].
	^ persistedVars! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 17:39'!
persistenceDescriptionForCollection: aCollection withLabel: ivn complexValues: aBool
	| ownerColumn collectionSample referenceColumn referenceTableName |
	ownerColumn := self ownerColumnForCurrentObject.
	
	collectionSample := nil.
	aCollection do: [:element | collectionSample ifNil: [collectionSample := element]].
	collectionSample := SqSBase for: collectionSample.
	referenceColumn := self referenceColumnDescriptionNamed: ivn for: collectionSample simpleValues: (aBool not).
			
	referenceTableName := aBool ifTrue: [self tableNameForClass: collectionSample baseClass] ifFalse: [nil].
			
	^ SqSCollectionDescription new
		referenceTableName: (referenceTableName);
		referenceColumn: referenceColumn;
		collectionClass: aCollection sqSaveClass;
		simpleValues: (aBool not);
		maintainOrder: self class useAdvancedCollections;
		ownerColumn: ownerColumn;
		includedClass: collectionSample baseClass;
		joinTableName: self currentObject baseClass name asSqSaveTableName , '_' , ivn decamelized! !

!SqSSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/9/2008 11:18'!
persistenceDescriptionForObject: anObject withLabel: aLabel storedInTableNamed: tableName 
	| linkedClass |
	linkedClass := (self isComplexObject: anObject) 
		ifTrue: [ anObject class name asSymbol ]
		ifFalse: [ nil ].
	^ self 
		createColumnDescriptionForObject: anObject
		withLabel: aLabel
		linkedTo: linkedClass
		storedInTableNamed: tableName! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 17:38'!
referenceColumnDescriptionNamed: ivn for: collectionSample simpleValues: aBool
	| referenceColumn sqlType |
	
	sqlType := self sqlTypeForObject: collectionSample sqsObject.

	referenceColumn := SqSColumnDescription new
		sqlType: sqlType;
		columnName: (self class collectionValueField);
		canBeNull: false.

	"create the foreign key relationship only if complex collections should be used
	or if our collection elements are no simple values but complex ones"
	((self class useAdvancedCollections) or: [aBool]) ifFalse: 
		[ referenceColumn foreignKey: (SqSForeignKeyDescription new
				referencedColumns: (OrderedCollection with: collectionSample sqSaveConnection class objectIdField);
				referencedTable: (self tableNameForClass: collectionSample baseClass);
				deleteActions: #(#CASCADE )) ].

	^referenceColumn! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 16:45'!
referenceColumnFor: collectionSample simpleValues: aBool 
	| referenceColumn sqlType |
	sqlType := self sqlTypeForObject: collectionSample sqsObject.
	referenceColumn := SqSColumnDescription new sqlType: sqlType;
				 columnName: (self class collectionValueField);
				 canBeNull: false.
	"create the foreign key relationship only if complex collections should be
	used or if our collection elements are no simple values but complex ones"
	(self class useAdvancedCollections
			or: [aBool])
		ifFalse: [referenceColumn foreignKey: (SqSForeignKeyDescription new
					referencedColumns: (OrderedCollection with: collectionSample sqSaveConnection class objectIdField);
					
					referencedTable: (self tableNameForClass: collectionSample baseClass);
					 deleteActions: #(#CASCADE ))].
	^ referenceColumn! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:12'!
tableNameForClass: aClass
	^(aClass respondsTo: (self class tableNameFunction)) ifTrue: [
		aClass perform: (self class tableNameFunction)	
	] ifFalse: [
		aClass name asSqSaveTableName
	]! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsOf: aClass
	^(aClass respondsTo: self class unpersistedInstVarsFunction) ifTrue: [
		(aClass perform: self class unpersistedInstVarsFunction)
	] ifFalse: [
		#()
	].! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 16:46'!
updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| previousClass oldDescription |
	oldDescription := aClass perform: ivn asSqSaveDescriptionSelector.
	"for the brave ones, we leave everything as is"
	oldDescription manuallyMaintained ifFalse: [
		oldDescription describesCollection ifFalse: [
			previousClass := Smalltalk at: oldDescription objectClass asSymbol.
			"if we have a subclass of our previous class, we're fine - otherwhise, we have to alter the table and the description"
			((anObject class inheritsFrom: previousClass) or: [anObject sqSaveClass = previousClass]) ifFalse: [
				self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
				"TODO: this is the place where we should ask the user if the change is ok???"
			]
		] ifTrue: [
			self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
		]
	].	
	! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:37'!
useInstVarAccessors
	^(self targetClass respondsTo: (self class useInstVarAccessorsFunction)) ifTrue: [
		self targetClass perform: (self class useInstVarAccessorsFunction)
	] ifFalse: [
		false
	]! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:42'!
writePersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass
	| description code |
	description := self createPersistenceDescriptorFor: ivn basedOn: anObject  inClass: targetClass.
	description ifNotNil: [
		code := ivn asSqSaveDescriptionSelector, String cr.
		code := code,'^', description creationCode.
		self compileMethodCode: code intoClass: targetClass
	].! !

Object subclass: #SqSDriver
	instanceVariableNames: 'objectCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:31'!
collectionOrderField
	^'order_number'! !

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:30'!
inheritanceTypeField
	^ 'sq_save_type_field'! !

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 9/1/2008 12:06'!
nilValue
	^0! !

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/5/2008 17:24'!
objectIdField
	^'oid'! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:42'!
addColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAddColumn: column).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 15:59'!
addEntries: addedIds inJoinTable: aDescription forOwnerId: oid
	addedIds do: [:ids |
		| sql |
		sql	:= self queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid.
		self executeQuery: sql.
	]	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/12/2008 14:08'!
allTableNames
	| result resultDicts tableNames |
	result := self executeQuery: 'SHOW TABLES'.
	resultDicts := self rowDictionariesForResultSet: result.
	tableNames := OrderedCollection new.
	resultDicts
		do: [:dict | dict
				valuesDo: [:tableName | tableNames add: tableName]].
	^ tableNames! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:47'!
alterColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAlterColumn: column).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'accessing' stamp: 'tkow 9/15/2008 17:15'!
assembleObjectOfClass: targetClass fromRow: resultDict 
	| oid object base |
	oid := resultDict at: self class objectIdField.
	object := self cachedObjectOf: targetClass withOid: oid.
	object
		ifNil: [object := targetClass new.
			base := SqSBase for: object.
			base persistedInstVars
				do: [:ivar | 
					| ivarValue | 
					ivarValue := resultDict
								at: (base columnNameForInstVar: ivar)
								ifAbsent: [SqSCollectionProxy
										for: nil
										ofInstVar: ivar
										in: object].
					base setInstVarNamed: ivar withValue: ivarValue].
			self cacheObject: object withOid: oid.
		].
	^ object! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tkow 9/10/2008 15:32'!
bodyForInsertOf: anObject 
	| fields values |
	fields := ''.
	values := ''.
	anObject class allClassTableColumns associationsDo: 
		[ :assoc | 
		fields := fields , assoc value columnName , ', '.
		values := values , (anObject escapedValueForInstVar: assoc key) , ', ' ].
	fields := fields allButLast: 2.
	values := values allButLast: 2.
	^ '(' , fields , ') VALUES (' , values , ')'! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:32'!
boolean
	^'BOOLEAN'.! !

!SqSDriver methodsFor: 'accessing' stamp: 'tkow 9/15/2008 17:34'!
cacheObject: anObject withOid: oid
	SqSBase cacheObject: anObject withOid: oid
	
! !

!SqSDriver methodsFor: 'accessing' stamp: 'tkow 9/8/2008 18:34'!
cachedObjectOf: targetClass withOid: oid 
	^ SqSBase 
		cachedObjectOfClass: targetClass
		withOid: oid! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/12/2008 14:05'!
checkTableExistance: aTableName 
	| result resultDicts blub |
	result := self executeQuery: 'SHOW TABLES'.
	resultDicts := self rowDictionariesForResultSet: result.
	blub := resultDicts
				select: [:dict | 
					dict values includes: aTableName].
	^ blub isEmpty not! !

!SqSDriver methodsFor: 'accessing' stamp: 'tkow 9/12/2008 13:38'!
close
	self subclassResponsibility! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:19'!
commitTransaction	
	self executeQuery:(self queryForCommit). .! !

!SqSDriver methodsFor: 'accessing' stamp: 'wh 8/17/2006 15:37'!
connection
	self subclassResponsibility.! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 5/13/2008 15:17'!
connectionIsAlive
	self subclassResponsibility.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:33'!
createJoinTableNamed: tableName withColumns: columns
	self executeQuery: (self queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: true). ! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:33'!
createJoinTableNamed: tableName withColumns: columns andOrderField: bool
	self executeQuery: (self queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: bool). ! !

!SqSDriver methodsFor: 'accessing' stamp: 'tkow 9/8/2008 18:49'!
createObjectsOfClass: aClass fromResultSet: result 
	| resultDicts targetClass object results |
	results := OrderedCollection new.
	resultDicts := self rowDictionariesForResultSet: result.
	resultDicts do: 
		[ :resultDict |
		targetClass := resultDicts first 
			at: self class inheritanceTypeField
			ifAbsent: [ aClass name ].
		targetClass := Smalltalk 
			at: targetClass asSymbol
			ifAbsent: [ nil ].
		targetClass ifNotNil: [ 
			object := self assembleObjectOfClass: targetClass fromRow: resultDict.
			results add: object 
		] 
	].
	^ results! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/10/2008 16:46'!
createTableFor: anSqsObject
	self createTableFor: anSqsObject withRealOid: true! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/10/2008 17:19'!
createTableFor: anSqsObject withRealOid: aBool
	| columns |
	columns := anSqsObject allClassTableColumns.
	aBool ifFalse: [
		columns at: self class objectIdField put: (self lightOidFieldDescriptionFor: (anSqsObject tableNameForClass: anSqsObject baseClass)) .
	].
	self executeQuery: (self queryToCreateTableNamed: (anSqsObject tableName) withColumns: columns)
! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 4/29/2008 17:20'!
database
	self subclassResponsibility.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
date
	^'DATE'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
dateAndTime
	^'DATETIME'.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
decimalIntegerSize: m scale: d
	^'DECIMAL('m asString,',',d asString,')'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
double
	^'DOUBLE'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
float
	^'FLOAT'.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/15/2008 16:52'!
getCollectionDescribedBy: descr forObjectId: oid
	| |
	^(descr simpleValues) ifTrue: [
		self getSimpleCollectionDescribedBy: descr forObjectId: oid
	] ifFalse: [
		self getComplexCollectionDescribedBy: descr forObjectId: oid.
	]

	
! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/15/2008 16:57'!
getSimpleCollectionDescribedBy: descr forObjectId: oid
	| sql resultDicts results value |
	sql := self queryToGetSimpleValuesForCollection: descr ofObjectId: oid.
	resultDicts := self rowDictionariesForResultSet: (self executeQuery: sql).
	results := OrderedCollection new.
	resultDicts do: [:resultRow |
		value := resultRow at: descr referenceColumn columnName ifAbsent: [nil].
		results add: value.
	].
	^results
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:15'!
inTransactionDo: aBlock
	self inTransactionDo: aBlock onError: [self rollback].! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/30/2008 14:36'!
inTransactionDo: aBlock onError: anErrorBlock
	self startTransaction.
	[aBlock value] ifError: [:err |
		"anErrorBlock value."
		self error: err.
	].
	self commitTransaction.
	! !

!SqSDriver methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 16:29'!
initialize
	super initialize.
	objectCache := WeakValueDictionary new.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
integer
	^'INTEGER'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
largeInteger
	^'BIGINT'.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 5/22/2008 17:04'!
lastOidFromTable: aTable
	self subclassResponsibility! !

!SqSDriver methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 16:54'!
lightOidFieldDescriptionFor: tableName 
	^ SqSColumnDescription new
		columnName: 'oid';
		sqlType: self unsignedInteger;
		canBeNull: false;
		isPrimaryKey: true;
		foreignKey: (SqSForeignKeyDescription new
				referencedColumns: #('oid' );
				deleteActions: #(#CASCADE );
				referencedTable: tableName)! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 7/29/2008 11:57'!
log: aString
	"TODO: viable solution for logging - Transcript is just weigh to slow"
	Transcript show: '+++++++++++++++++++';
		show: String cr;
		show: aString;
		show: String cr.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
mediumInteger
	^'MEDIUMINT'.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 15:47'!
moveEntries: movedIds inJoinTable: aDescription forOwnerId: oid
	| sql |
	movedIds do: [:ids |
		sql := self queryToUpdateEntries: ids inJoinTable: aDescription forOwnerId: oid.
		self executeQuery: (sql).
	]
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:34'!
oid
	^self unsignedInteger, ' PRIMARY KEY '.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:30'!
oidColumn
	"I believe this is the SQL standard but I don't think any SQL databases 
		follow it "

	^'INTEGER PRIMARY KEY GENERATED ALWAYS AS IDENTITY'! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 19:51'!
performSearchForObjectsOfClass: aClass withArguments: argumentDictionary andLimit: aLimit
	| sql result results |
	sql := 'SELECT * FROM ', (argumentDictionary keys join: ' NATURAL JOIN '), ' WHERE '.
	argumentDictionary associationsDo: [:assoc |
		assoc value associationsDo: [ :joiner |
			sql := sql, '('.
			sql := sql, ((joiner value collect: [:searchAttr |
				assoc key,'.', searchAttr key, ' = ', searchAttr value asSqlValueString
			]) join: (' ',joiner key,' ')).
			sql := sql,') AND '.
		].
	].
	sql := sql allButLast: 5.
	aLimit ifNotNil: [sql := sql, ' LIMIT ', aLimit asString].
	result := self executeQuery: (sql).
	results := self createObjectsOfClass: aClass fromResultSet: result.
	^results! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/10/2006 17:05'!
queryForCommit
	^'COMMIT'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 7/10/2008 17:15'!
queryForForeignKeyConstraint: aForeignKeyDescription ofColumn: aColumnName
	| sql |
	sql := 'FOREIGN KEY (',aColumnName,') REFERENCES '.
	sql := sql, aForeignKeyDescription referencedTable,'(', aForeignKeyDescription referencedColumns first,') '.
	aForeignKeyDescription deleteActions ifNotEmpty: [sql := sql, 'ON DELETE'].
	aForeignKeyDescription deleteActions do: [:action | sql := sql, ' ',action].
	aForeignKeyDescription updateActions ifNotEmpty: [sql := sql, 'ON UPDATE'].
	aForeignKeyDescription updateActions do: [:action | sql := sql, ' ',action].
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:30'!
queryForObjectsOf: aClass byAttributes: argumentDictionary inTable: aTableName withLimit: limit 
	| query result results |
	query := 'SELECT * FROM ' , aTableName , ' WHERE '.
	(aClass descriptionHandler inheritanceModeForClass: aClass) = #singleTableInheritance ifTrue: 
		[ query := query , '( ' , self class inheritanceTypeField , ' = ' , aClass name asSqlValueString.
		aClass allSubclasses do: 
			[ :subClass | 
			query := query , ' OR ' , self class inheritanceTypeField , ' = ' , subClass name asSqlValueString ].
		query := query , ') AND ' ].
	argumentDictionary associationsDo: 
		[ :pair | 
		query := query , pair key , ' = ' , pair value asSqlValueString , ' AND ' ].
	query := query allButLast: 5.
	limit ifNotNil: [ query := query , ' LIMIT ' , limit asString ].
	result := self executeQuery: query.
	results := self 
		createObjectsOfClass: aClass
		fromResultSet: result.
	^ results! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/11/2006 09:23'!
queryForRollback
	^'ROLLBACK'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/13/2006 12:41'!
queryForStartTransaction
	^'START TRANSACTION'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:45'!
queryToAddColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' ADD COLUMN '.
	sql := sql, aColumn columnName, ' ', aColumn sqlType.
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 9/2/2008 11:35'!
queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid
	| sql |
	sql := 'INSERT INTO ', aDescription joinTableName, '('.
	sql := sql, aDescription ownerColumn columnName, ', ', aDescription referenceColumn columnName. 
	aDescription maintainOrder ifTrue: [
		sql := sql, ', ', self	class collectionOrderField
	].
	sql := sql, ') VALUES (', oid asString, ',', (ids join: ','), ')'.
	^sql
	! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:48'!
queryToAlterColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' MODIFY '.
	sql := sql, aColumn columnName, ' ', aColumn sqlType.
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 6/19/2008 16:56'!
queryToAlterColumns: anAssociation forTable: tableName
	| sql |
	sql := 'ALTER TABLE ',tableName, ' MODIFY '.
	sql	:= sql, (self escapedRowName: anAssociation key), ' ', anAssociation value.
	^sql.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:43'!
queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool
	| sql |
	sql := 'CREATE TABLE ', tableName, ' ('.
	"create the three (or two...) columns of the join table"
	columns do: [ :columnDescr |
		sql := sql, columnDescr columnName, ' ', columnDescr sqlType.
		columnDescr foreignKey ifNotNil: [
			sql := sql, ' NOT NULL, ', (self queryForForeignKeyConstraint: columnDescr foreignKey ofColumn: columnDescr columnName). 	
		].
		sql := sql, ', '.
	].
	aBool ifTrue: [
		sql := sql, self class collectionOrderField,' ',(self integer),' NOT NULL, '.
	].
	
	"and set up a primary key over those columns (will be always unique)"
	sql := sql, ' PRIMARY KEY (', ((columns collect: [:columnDescr | columnDescr columnName]) join: ', ').
	aBool ifTrue: [
		sql := sql, ', ',self class collectionOrderField.
	].
	sql := sql, '))'.
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 5/22/2008 15:31'!
queryToCreateObject: anObject
	|sql|
	sql := 'INSERT INTO ', anObject tableName, ' '.
	sql := sql,(self bodyForInsertOf: anObject). 
	^sql.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tkow 9/10/2008 17:02'!
queryToCreateTableNamed: tableName withColumns: columnDict 
	| sql type primaryKeyColumns |
	sql := 'CREATE TABLE ' , tableName , ' ('.
	(columnDict includesKey: (self class objectIdField )) ifFalse: [ sql := sql , self class objectIdField, ' ' , self oidColumn , ',' ].
	columnDict associationsDo: 
		[ :assoc | 
		type := self smallInteger.
		assoc value sqlType 
			ifNil: 
				[ assoc key = self class inheritanceTypeField ifTrue: [ type := self string ] ]
			ifNotNil: [ type := assoc value sqlType ].
		sql := sql , (self escapedRowName: assoc value columnName) , ' ' , type.
		assoc value canBeNull ifFalse: [ sql := sql , ' NOT NULL' ].
		sql := sql , ', '.
		assoc value foreignKey ifNotNil: 
			[ sql := sql , (self 
					queryForForeignKeyConstraint: assoc value foreignKey
					ofColumn: assoc key) , ', ' ] ].
	sql := sql allButLast: 2.
	primaryKeyColumns := (columnDict values select: [ :columnDescr | columnDescr isPrimaryKey ]) collect: [ :columnDescr | columnDescr columnName ].
	primaryKeyColumns ifNotEmpty: 
		[ sql := sql , ', PRIMARY KEY (' , (primaryKeyColumns join: ', ') , ')' ].
	sql := sql , ')'.
	^ sql! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/15/2008 17:04'!
queryToGetSimpleValuesForCollection: descr ofObjectId: oid
	| sql |
	sql := 'SELECT * FROM ', descr joinTableName.
	sql := sql, ' WHERE ', descr ownerColumn columnName,' = ', oid asSqlValueString.
	descr maintainOrder ifTrue: [
		sql := sql, ' ORDER BY ', self class collectionOrderField
	].
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:46'!
queryToRemoveColumn: aColumn
	^'ALTER TABLE ',aColumn tableName,' DROP COLUMN ', aColumn columnName.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/29/2008 15:31'!
queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid
	| sql |
	sql := 'DELETE FROM ', aDescription joinTableName, ' WHERE '.
	sql := sql, columnName, ' IN (', (ids join: ','), ') AND '.
	sql := sql, aDescription ownerColumn columnName, ' = ', oid asString.
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 4/29/2008 16:11'!
queryToRemoveTableForClass: aClass
	| sql |
	sql := 'DROP TABLE ', aClass name.
	^sql.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:41'!
queryToRenameColumns: columnsCollection
	| oldColumn sql newColumn |
	oldColumn := columnsCollection first.
	newColumn := columnsCollection at: 2.
	sql := 'ALTER TABLE ', oldColumn tableName, ' CHANGE '.
	sql := sql, oldColumn columnName, ' ', newColumn columnName, ' ', newColumn sqlType.
	^sql 
	! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/29/2008 15:54'!
queryToUpdateEntries: movedIds inJoinTable: aDescription forOwnerId: oid
	"orderNumber := movedIds last.
	newObjectId := movedIds first."
	| sql |
	sql := 'UPDATE ', aDescription joinTableName, '	SET '.
	sql := sql, aDescription referenceColumn columnName, ' = ', movedIds first asString.
	sql := sql, ' WHERE ', aDescription ownerColumn columnName, ' = ', oid asString.
	sql := sql, ' AND ', self class collectionOrderField, ' = ', movedIds last asString.
	^sql
	
	
	! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 7/21/2008 14:18'!
reconnect
	self subclassResponsibility.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:45'!
removeColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToRemoveColumn: column).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 15:29'!
removeEntries: deletedIds fromJoinTable: aDescription forOwnerId: oid
	| sql ids columnName |
	aDescription maintainOrder ifTrue: [
		ids := deletedIds collect: [: dids | dids last].
		columnName := self class collectionOrderField.
	] ifFalse: [
		ids := deletedIds collect: [: dids | dids first].
		columnName := aDescription referenceColumn columnName
	].
	sql := self queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid.
	self executeQuery: sql.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/15/2008 16:06'!
removeObjectWithId: oid fromTable: tableName
	| sql |
	sql := 'DELETE FROM ',tableName,' WHERE oid = ',oid asString.
	self executeQuery: (sql).! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:41'!
renameColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:columnPair |
			self executeQuery: (self queryToRenameColumns: columnPair).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tkow 9/12/2008 14:18'!
resetDatabase
	| tables |
	tables := self allTableNames.
	tables ifNotEmpty: [
		"the second one is for tables that are somehow linked to others by foreign key constraints"
		[self executeQuery: ('DROP TABLE IF EXISTS ', (tables join: ', '))] on: Error do: [
			self executeQuery: ('DROP TABLE IF EXISTS ', (tables join: ', '))
		]
	].
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/18/2008 16:22'!
rollback
	"self localCache do:[:object | object rollback ].
	self rollbackDbTransaction."
	"self executeQuery: 'ROLLBACK'"! !

!SqSDriver methodsFor: 'database operations' stamp: 'wh 8/11/2006 09:24'!
rollbackDbTransaction
	self executeQuery:(self queryForRollback) .! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 8/31/2008 15:05'!
rowDictionariesForResultSet: result
	^self subclassResponsibility! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
smallInteger
	^'SMALLINT'! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:18'!
startTransaction
	self executeQuery:(self queryForStartTransaction).! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 15:42'!
storeColumns: columnDict inTable: aTableName
	self storeColumns: columnDict inTable: aTableName  andReturnOId: false.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:07'!
storeColumns: columnDict inTable: aTableName andReturnOId: aBool
	"columnDict is a Dictionary where a SqSaveColumnDescription points to the stored value"
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := ''.
	columnDict associationsDo: [:assoc |
		keys := keys, assoc key, ', '.
		values := values, assoc value asString, ', '.	
	].
	sql := sql, (keys allButLast: 2), ') VALUES (', (values allButLast: 2), ')'.
	self executeQuery: (sql).
	aBool ifTrue: [
		^self lastOidFromTable: aTableName	
	].! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
string
	^self stringWithLength: 254.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:21'!
stringWithLength: m
	^'VARCHAR(',m asString,')'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
text
	^'TEXT'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
time
	^'TIME'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/16/2006 22:18'!
unsignedInteger
	"The SQL standard does not support unsigned Integer 
		imagine my suprise "
	^'INTEGER '.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:14'!
updateFields: columnDict ofObjectWithId: oid inTable: aTableName 
	| sql |
	sql := 'UPDATE ' , aTableName , ' SET '.
	columnDict associationsDo: [ :assoc | sql := sql , assoc key , ' = ' , assoc value asString , ', ' ].
	sql := (sql allButLast: 2) , ' WHERE oid = ' , oid asString.
	self executeQuery: sql! !

SqSDriver subclass: #SqSMySQLDriver
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSMySQLDriver class methodsFor: 'as yet unclassified' stamp: 'wh 8/8/2006 23:11'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	^(self new ) 
		onHost: aHost 
		port: aPort 
		withUser: aUser 
		password: aPassword 
		database: aDatabase.! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tkow 9/12/2008 13:38'!
close
	self connection close! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:18'!
connection
	^connection! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 7/18/2008 15:53'!
connectionIsAlive
	^self connection socket isConnected! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 4/29/2008 17:22'!
database
	^connection connectionSpec database! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 9/2/2008 14:29'!
driverClass
	^JdmConnection! !

!SqSMySQLDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSMySQLDriver methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:54'!
executeQuery: aQuery
	| |
	self log: aQuery.
	^(self connection createStatement) executeQuery:(aQuery)! !

!SqSMySQLDriver methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:55'!
lastOidFromTable: aTable
	 | oid |
	"MySQL will only retrun the last ID. Postgres needs the table part"  
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:20'!
newConnection
	^ self driverClass on: (self connection connectionSpec).! !

!SqSMySQLDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:21'!
oidColumn
	^'INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT '.! !

!SqSMySQLDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 16:27'!
oidForNewObject: anObject
	 | oid |
	(self connection createStatement) executeQuery: (self queryForNewObjectOfClass:(anObject class)).
	"Ugh MySQL driver trickery"
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/16/2006 23:39'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	| spec |
	Socket initializeNetwork.
	spec :=    (JdmConnectionSpec new initialize
        user: aUser; password: aPassword;
        host: (NetNameResolver addressForName: aHost);
        database: aDatabase;
        port: aPort).
	connection := (self driverClass) on: spec.
	! !

!SqSMySQLDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:35'!
queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool
	^ (super queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool) , ' ENGINE=INNODB'.! !

!SqSMySQLDriver methodsFor: 'sql statements' stamp: 'tk 7/10/2008 16:54'!
queryToCreateTableNamed: tableName withColumns: columnDict
	^ (super queryToCreateTableNamed: tableName withColumns: columnDict) , ' ENGINE=INNODB'.! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 7/29/2008 11:56'!
reconnect
	self log: 'reconnecting'.
	[connection close] ifError: [:err | Transcript show: err].
	connection initialize2.! !

!SqSMySQLDriver methodsFor: 'converting' stamp: 'tk 8/31/2008 15:06'!
rowDictionariesForResultSet: result 
	| resultDicts |
	resultDicts := OrderedCollection new.
	"store all data rows in our own structure - this way we can issue new commands upon object creation"
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary copy ].
	^resultDicts! !

Object subclass: #SqSForeignKeyDescription
	instanceVariableNames: 'referencedColumns referencedTable updateActions deleteActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions
	^ deleteActions! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions: anObject
	deleteActions := anObject! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:31'!
initialize
	super initialize.
	self updateActions: #().
	self deleteActions: #().! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns
	^ referencedColumns! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns: anObject
	referencedColumns := anObject! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable
	^ referencedTable! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable: anObject
	referencedTable := anObject! !

!SqSForeignKeyDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/22/2008 13:54'!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;;
				nextPutAll: (String cr, String tab, String tab)
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions
	^ updateActions! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions: anObject
	updateActions := anObject! !

Object subclass: #SqSMagritteDescriptionCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSMagritteDescriptionCreator methodsFor: 'as yet unclassified' stamp: 'tk 8/31/2008 15:16'!
createDescriptorNamed: aSelector for: anObject withLabel: aLabel inClass: aClass
	| code |
	code := aSelector,String cr,(self descriptorCodeFor: aLabel basedOn: anObject),String cr.
	self compileMethodCode: code intoClass: aClass.
	! !

!SqSMagritteDescriptionCreator methodsFor: 'as yet unclassified' stamp: 'tk 8/31/2008 15:16'!
descriptionCodeFor: anObject labeled: aLabel withClass: className
	| code |
	code := String tab,'^',className asString,' new', (self indent: 2).
	code := code, 'selectorAccessor: #', aLabel, ';',(self indent: 2).
	code := code, 'label: ''', aLabel,''';',(self indent: 2).
	(anObject respondsTo: #magritteDescriptionDefaultValue) ifTrue: [
		code := code, 'default: ', anObject magritteDescriptionDefaultValue, ';', (self indent: 2). 	
	].
	code := code, 'yourself'.
	^code! !

!SqSMagritteDescriptionCreator methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
descriptorCodeFor: aLabel basedOn: anObject 
	| className code |
	className := anObject class name.
	(anObject respondsTo: #magritteDescriptionClass) 
		ifTrue: 
			[ code := self 
				descriptionCodeFor: anObject
				labeled: aLabel
				withClass: anObject magritteDescriptionClass ]
		ifFalse: 
			[ (anObject class inheritsFrom: Collection) 
				ifTrue: 
					[ code := self 
						descriptionCodeFor: anObject
						labeled: aLabel
						withClass: #MAToManyRelationDescription ]
				ifFalse: 
					[ (anObject class inheritsFrom: SqSBase) ifTrue: 
						[ code := self 
							descriptionCodeFor: anObject
							labeled: aLabel
							withClass: #MAToOneRelationDescription ] ] ].
	^ code! !

Object subclass: #SqSPersistenceDescription
	instanceVariableNames: 'associatedClass manuallyMaintained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqSPersistenceDescription subclass: #SqSCollectionDescription
	instanceVariableNames: 'collectionClass joinTableName ownerColumn referenceColumn referenceTableName includedClass maintainOrder simpleValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass
	^ collectionClass! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass: anObject
	collectionClass := anObject! !

!SqSCollectionDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/23/2008 15:13'!
describesCollection
	^true! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/12/2008 16:58'!
includedClass
	^ includedClass! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/12/2008 16:58'!
includedClass: anObject
	includedClass := anObject! !

!SqSCollectionDescription methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 13:20'!
initialize
	super initialize.
	self simpleValues: false.! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName
	^ joinTableName! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName: anObject
	joinTableName := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder
	^ maintainOrder! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder: anObject 
	maintainOrder := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn
	^ ownerColumn! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn: anObject
	ownerColumn := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn
	^ referenceColumn! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn: anObject
	referenceColumn := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName
	^ referenceTableName! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName: anObject
	referenceTableName := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues
	^ simpleValues! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues: anObject
	simpleValues := anObject! !

SqSPersistenceDescription subclass: #SqSColumnDescription
	instanceVariableNames: 'columnName sqlType objectClass tableName foreignKey canBeNull isPrimaryKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull
	^ canBeNull! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull: anObject
	canBeNull := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName
	^ columnName! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey
	^ foreignKey! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:16'!
foreignKey: anObject
	foreignKey := anObject.
	"being a foreign key, the column can not be null"
	self canBeNull: false.! !

!SqSColumnDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/14/2008 13:41'!
initialize
	super initialize.
	self canBeNull: true.
	self isPrimaryKey: false.! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey
	^ isPrimaryKey! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey: anObject
	isPrimaryKey := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass
	^ objectClass! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass: anObject
	objectClass := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName
	^ tableName! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName: anObject
	tableName := anObject! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:16'!
adaptObject: anObject
	self associatedClass ifNil: [
		^anObject	
	] ifNotNil: [
		^(Smalltalk at: (self associatedClass asSymbol)) findByOid: anObject 
	]! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 14:44'!
creationCode
	| aStream |
	aStream := TextStream on: String new.

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream 
				nextPutAll: (String cr, String tab);
				nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.
	^aStream contents
	! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/23/2008 15:12'!
describesCollection
	^false! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:37'!
initialize
	super initialize.
	self manuallyMaintained: false.! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained
	^ manuallyMaintained! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained: anObject
	manuallyMaintained := anObject! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/5/2008 18:58'!
storeOn: aStream
	aStream nextPutAll: self creationCode! !

Object subclass: #SqSProxyObject
	instanceVariableNames: 'proxiedVariable targetObject actualObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSProxyObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 13:23'!
forAttribute: ivarName ofClass: aClass
	^(self new
		proxiedVariable: ivarName;
		targetClass: aClass;
		yourself)! !

!SqSProxyObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 15:43'!
forAttribute: ivarName ofObject: aClass
	^(self new
		proxiedVariable: ivarName;
		targetObject: aClass;
		yourself)! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
actualObject
	^ actualObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
actualObject: anObject
	actualObject := anObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 13:21'!
proxiedVariable
	^ proxiedVariable! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 13:21'!
proxiedVariable: anObject
	proxiedVariable := anObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
targetObject
	^ targetObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
targetObject: anObject
	targetObject := anObject! !

Object subclass: #SqSTableStructureHandler
	instanceVariableNames: 'currentObject'
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqSTableStructureHandler subclass: #SqSClassTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 17:25'!
buildSearchFor: instVars withValues: values 
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName baseClassTableName |
	descrHandler := self currentObject descriptionHandler.
	targetClass := self currentObject sqsObject class.
	searchDict := Dictionary new.
	baseClass := self currentObject baseClass.
	typeField := self currentObject sqSaveConnection class inheritanceTypeField.
	
	baseClassTableName := self currentObject tableNameForClass: baseClass.
	
	instVars withIndexDo: 
		[ :ivar :index | 
		ivar = (self currentObject sqSaveConnection class objectIdField) 
			ifTrue: 
				[ tableName := baseClassTableName.
				columnName := (self currentObject sqSaveConnection class objectIdField)  ]
			ifFalse: 
				[ descr := descrHandler columnDescriptionFor: ivar.
				tableName := descr tableName.
				columnName := descr columnName ].
		(searchDict 
			at: tableName
			ifAbsentPut: Dictionary new) 
			at: #AND
			ifAbsentPut: Set new.
		((searchDict at: tableName) at: #AND) add: columnName -> (values at: index) ].
	(searchDict 
		at: baseClassTableName
		ifAbsentPut: Dictionary new) 
		at: #OR
		ifAbsentPut: Set new.
	((searchDict at: baseClassTableName) at: #OR) add: typeField -> targetClass name.
	targetClass allSubclasses do: [ :sc | ((searchDict at: baseClassTableName) at: #OR) add: typeField -> sc name ].
	[ targetClass ~= baseClass ] whileTrue: 
		[ searchDict 
			at: (self currentObject tableNameForClass: targetClass)
			ifAbsentPut: Dictionary new.
		targetClass := targetClass superclass ].
	^ searchDict! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 17:56'!
createColumnDictionaries
	| baseClass columnDict klass columns infoDict base |
	columns := OrderedCollection new.
	baseClass := self currentObject baseClass.
	base := SqSBase for: baseClass new.
	infoDict := Dictionary new.
	infoDict at: #tableName put: base tableName.
	columnDict := Dictionary new.
	base allClassTableColumns
		associationsDo: [:assoc | columnDict
				at: assoc value columnName
				put: (self currentObject escapedValueForInstVar: assoc key)].
	infoDict at: #columns put: columnDict.
	columns add: infoDict.
	klass := self currentObject sqsObject class.
	[klass ~= baseClass]
		whileTrue: [infoDict := Dictionary new.
			base := SqSBase for: klass new.
			infoDict at: #tableName put: base tableName.
			columnDict := Dictionary new.
			base allClassTableColumns
				associationsDo: [:assoc | columnDict
						at: assoc value columnName
						put: (self currentObject escapedValueForInstVar: assoc key)].
			infoDict at: #columns put: columnDict.
			columns add: infoDict.
			klass := klass superclass].
	^ columns! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 16:15'!
createSpecificTableStructure
	| sampleClass connection baseClass base |
	sampleClass := self currentObject sqsObject class.
	baseClass := self currentObject baseClass.
	connection := self currentObject sqSaveConnection.
	
	"create the base class table first, if it does not already exist"
	base := SqSBase for: baseClass new.
	base tableForClassExists ifFalse: [connection createTableFor: (base)].
	(TableCache at: baseClass name) at: base tableName put: base allClassTableColumns.
		
	"the create all other tables in the hierarchy"
	[ sampleClass = baseClass] whileFalse: [
		base := SqSBase for: sampleClass new.
		base tableForClassExists ifFalse: [
			connection createTableFor: base withRealOid: false	
		].
		(TableCache at: baseClass name) at: base tableName put: base allClassTableColumns.
		sampleClass := sampleClass superclass
	]! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 17:00'!
deleteObject
	"this is were the beauty of foreign key constraints kicks in - just delete the object in the base table"
	^ self currentObject sqSaveConnection 
		removeObjectWithId: self currentObject oid
		fromTable: (self currentObject tableNameForClass: self currentObject baseClass)! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 17:14'!
insertCurrentObject
	| connection baseClass columnDict lastOid klass base |
	connection := self currentObject sqSaveConnection.
	baseClass := self currentObject baseClass.
	columnDict := Dictionary new.
	base := SqSBase for: baseClass new.
	base allClassTableColumns
		associationsDo: [:assoc | columnDict
				at: assoc value columnName
				put: (self currentObject escapedValueForInstVar: assoc key)].
	"connection inTransactionDo: 
	["
	lastOid := connection
				storeColumns: columnDict
				inTable: base tableName
				andReturnOId: true.
	klass := self currentObject sqsObject class.
	[klass ~= baseClass]
		whileTrue: [columnDict := Dictionary new.
			base := SqSBase for: klass new.
			base allClassTableColumns
				associationsDo: [:assoc | columnDict
						at: assoc value columnName
						put: (self currentObject escapedValueForInstVar: assoc key)].
			columnDict at: connection class objectIdField put: lastOid.
			connection storeColumns: columnDict inTable: base tableName.
			klass := klass superclass
			"]"].
	^ lastOid! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 11:15'!
instVarsForClassTable
	| instVars |
	instVars := Set newFrom: (
		self currentObject sqsObject class instVarNames difference: (
			self currentObject unpersistedInstVars
		)
	).
	(self currentObject sqsObject class = self currentObject baseClass) ifTrue: [ 
		instVars add: SqSDriver inheritanceTypeField 
	].
	^ instVars! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:23'!
structureSpecificChangedColumns
	| baseClass changes currentSqSBase oldColumns newColumns |
	baseClass := self currentObject baseClass.
	changes := Dictionary new.
	"iterate over all superclasses of the object to store"
	self currentObject
		doForAllSuperclasses: [:aClass | 
			"determine the current table columns"
			currentSqSBase := SqSBase for: aClass new.
			newColumns := currentSqSBase allClassTableColumns.
			"get the old columns from cache"
			oldColumns := (TableCache at: baseClass name)
						at: currentSqSBase tableName
						ifAbsent: [Dictionary new].
			"calculate the differences between them"
			changes
				valueJoin: (self detectColumnDifferencesBetween: oldColumns and: newColumns).
			"update the cache"
			(TableCache at: baseClass name)
				at: currentSqSBase tableName
				put: newColumns].
	^ changes! !

SqSTableStructureHandler subclass: #SqSSingleTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 18:06'!
buildSearchFor: instVars withValues: values 
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName baseClassTableName |
	descrHandler := self currentObject descriptionHandler.
	targetClass := self currentObject sqsObject class.
	searchDict := Dictionary new.
	baseClass := self currentObject baseClass.
	typeField := self currentObject sqSaveConnection class inheritanceTypeField.
	baseClassTableName := self currentObject tableNameForClass: baseClass.
	
	instVars
		withIndexDo: [:ivar :index | 
			ivar = (self currentObject sqSaveConnection class objectIdField) 
				ifTrue: [tableName := baseClassTableName.
					columnName := (self currentObject sqSaveConnection class objectIdField) ]
				ifFalse: [descr := descrHandler columnDescriptionFor: ivar.
					tableName := descr tableName.
					columnName := descr columnName].
			(searchDict at: tableName ifAbsentPut: Dictionary new)
				at: #AND
				ifAbsentPut: Set new.
			((searchDict at: tableName)
				at: #AND)
				add: columnName
						-> (values at: index)].
	(searchDict at: (baseClassTableName) ifAbsentPut: Dictionary new)
		at: #OR
		ifAbsentPut: Set new.
	((searchDict at: baseClassTableName)
		at: #OR)
		add: typeField -> targetClass name.
	targetClass allSubclasses
		do: [:sc | ((searchDict at: (baseClassTableName))
				at: #OR)
				add: typeField -> sc name].
	^ searchDict! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:32'!
createColumnDictionaries
	| columnDict infoDict |
	columnDict := Dictionary new.
	self currentObject allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstVar: assoc key) ].
	infoDict := Dictionary newFrom: { 
			(#tableName -> self currentObject tableName).
			(#columns -> columnDict)
		 }.
	^ OrderedCollection with: infoDict! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 17:39'!
createSpecificTableStructure
	| connection |
	connection := self currentObject sqSaveConnection.
	self updateTableCache.
	connection createTableFor: self currentObject
		! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:48'!
deleteObject
	^ self currentObject sqSaveConnection removeObjectWithId: self currentObject oid fromTable: self currentObject tableName! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:32'!
insertCurrentObject
	| columnDict connection |
	columnDict := Dictionary new.
	connection := self currentObject sqSaveConnection.
	self currentObject allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstVar: assoc key) ].
	^ connection 
		storeColumns: columnDict
		inTable: self currentObject tableName
		andReturnOId: true! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 11:33'!
instVarsForClassTable
	| allInstVars targetClass currentClass |
	targetClass := self currentObject sqsObject class.
	allInstVars := Set new.
	currentClass := targetClass.
	[currentClass = self currentObject baseClass superclass]
		whileFalse: [allInstVars addAll: currentClass instVarNames.
			currentClass := currentClass superclass].
	allInstVars := allInstVars difference: self currentObject unpersistedInstVars.
	allInstVars
		ifNotEmpty: [allInstVars add: SqSDriver inheritanceTypeField].
	^ allInstVars! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:16'!
structureSpecificChangedColumns
	| oldColumns newColumns changes |
	oldColumns := Dictionary new.
	newColumns := self currentObject allClassTableColumns.

	self currentObject doForAllSuperclasses: [:aClass |
		oldColumns := oldColumns union: ((self tableCacheForClass: aClass) 
			at: (self currentObject tableName)
			ifAbsent: [Dictionary new])
	].

	changes := self detectColumnDifferencesBetween: oldColumns and: newColumns.
	self updateTableCache.
	^ changes! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 17:38'!
updateTableCache
	| currentClass baseClass currentBase currentColumns nextColumns |
	currentClass := self currentObject sqsObject class.
	baseClass := self currentObject baseClass.
	[currentClass = baseClass superclass] whileFalse: [
		currentBase := SqSBase for: (currentClass new).
		currentColumns := currentBase allClassTableColumns.
		nextColumns := (currentClass = baseClass) ifTrue: [
			Dictionary new	
		] ifFalse: [
			(SqSBase for: currentClass superclass new) allClassTableColumns
		].
		
		TableCache at: currentClass name ifAbsentPut: [Dictionary new].
		(TableCache at: currentClass name) 
			at: currentBase tableName 
			put: (currentColumns keysSelect: [:key | (nextColumns includesKey: key) not ]).
		currentClass := currentClass superclass
	].! !

!SqSTableStructureHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:56'!
classTableInheritance
	^#classTableInheritance! !

!SqSTableStructureHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:11'!
for: anObject 
	"determine the proper structure handler class"
	| inheritanceMode targetClass |
	inheritanceMode := anObject descriptionHandler inheritanceMode.
	targetClass := 'SqS' , inheritanceMode capitalized , 'TableStructureHandler'.
	targetClass := Smalltalk
				at: targetClass asSymbol
				ifAbsent: [self error: 'Unknown inheritance Mode'].
	"initialize the table cache (if not already done...)"
	TableCache
		ifNil: [TableCache := Dictionary new].
	"and return a completely new handler"
	^ targetClass new currentObject: anObject;
		 yourself! !

!SqSTableStructureHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/10/2008 15:56'!
singleTableInheritance
	^#singleTableInheritance! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:07'!
buildSearchFor: instVars withValues: values
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/17/2008 16:15'!
createColumnDictionaries
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
createJoinTableFromDescription: reference 
	| referenceColumn ownerColumn columns descr |
	descr := reference at: #description.
	referenceColumn := descr referenceColumn.
	ownerColumn := descr ownerColumn.
	columns := OrderedCollection 
		with: ownerColumn
		with: referenceColumn.
	self currentObject sqSaveConnection 
		createJoinTableNamed: descr joinTableName
		withColumns: columns
		andOrderField: descr maintainOrder.
	self insertJoinTableDescriptionToCache: reference! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/14/2008 11:51'!
createSpecificTableStructure
	^self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:19'!
createTableStructure
	self currentObject
		doForAllSuperclasses: [:aClass | TableCache at: aClass name put: Dictionary new].
	self currentObject sqsObject class allSubclasses
		do: [:aClass | TableCache at: aClass name put: Dictionary new].
	self createSpecificTableStructure.
	self currentObject indirectlyReferencedObjects
		do: [:reference | self createJoinTableFromDescription: reference]! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:05'!
currentObject
	^ currentObject! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:04'!
currentObject: anObject 
	currentObject := anObject! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 17:35'!
deleteObject
	^self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:11'!
detectColumnDifferencesBetween: oldColumns and: curColumns 
	| curCol prevCol changedColumns |
	changedColumns := Dictionary newFrom: { (#renamed -> Set new).(#deleted -> Set new).(#altered -> Set new).(#added -> Set new)}.
	oldColumns associationsDo: 
		[ :assoc | 
		curCol := curColumns at: assoc key.
		prevCol := assoc value.
		"if we can't find the current column for an old one it has been deleted'"
		curCol 
			ifNil: [ (changedColumns at: #deleted) add: prevCol ]
			ifNotNil: 
				[ "if the name's different, add it to changed'"
				curCol columnName ~= prevCol columnName ifTrue: 
					[ (changedColumns at: #renamed) add: (OrderedCollection 
							with: prevCol
							with: curCol) ].
				"same for sql type"
				(curCol sqlType ~= prevCol sqlType and: [ curCol sqlType isNil not ]) ifTrue: [ (changedColumns at: #altered) add: curCol ] ] ].
	"and now find the columns that have been added"
	(changedColumns at: #added) addAll: (curColumns associationsSelect: [ :assoc | (oldColumns includesKey: assoc key) not ]) values.
	^changedColumns! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:49'!
findChangedColumnsInJoinTable: aDescr ofClass: aClass
	| oldDescription changedColumns descr |
	descr := aDescr at: #description.
	
	oldDescription := ((TableCache at: aClass name) at: descr joinTableName).
	
	changedColumns := Dictionary new.	
	(oldDescription ownerColumn columnName ~= descr ownerColumn columnName) ifTrue: [
		changedColumns at: #renamed put: descr ownerColumn	
	].

	(oldDescription referenceColumn columnName ~= descr referenceColumn columnName) ifTrue: [
		changedColumns at: #renamed put: descr referenceColumn	
	].

	(oldDescription ownerColumn sqlType ~= descr ownerColumn sqlType) ifTrue: [
		changedColumns at: #altered put: descr ownerColumn	
	].

	(oldDescription referenceColumn sqlType ~= descr referenceColumn sqlType) ifTrue: [
		changedColumns at: #altered put: descr referenceColumn	
	].
	
	"finally set up the table cache at the corresponding entry..."
	(TableCache at: aClass name) at: descr joinTableName put: descr.

	^changedColumns


	! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 15:07'!
getChangedColumns
	| baseClass joinChanges descr |
	baseClass := self currentObject baseClass.
	joinChanges := Dictionary new.
	self currentObject indirectlyReferencedObjects do: 
		[ :reference | 
		descr := reference at: #description.
		((TableCache at: baseClass name) includesKey: descr joinTableName) 
			ifTrue: 
				[ joinChanges valueJoin: (self 
						findChangedColumnsInJoinTable: reference
						ofClass: baseClass) ]
			ifFalse: [ self createJoinTableFromDescription: reference ] ].
	^ joinChanges valueJoin: self structureSpecificChangedColumns! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:12'!
insertCurrentObject
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/5/2008 14:54'!
insertJoinTableDescriptionToCache: reference 
	| descr |
	descr := reference at: #description.
	(TableCache at: self currentObject baseClass name)
		at: descr joinTableName
		put: descr! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/8/2008 11:42'!
insertObject
	"first store all objects that are directly referenced by the main object - i.e.
	one-to-one relations"
	| oid |
	self currentObject directlyReferencedObjects
		do: [:obj | obj save].
	"next store the object itself"
	oid := self insertCurrentObject.
	self currentObject oid: oid.
	"store all objects the sample object holds within one-to-many associations
	- they explicitly need the oid"
	self insertOwnedCollections! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 16:04'!
insertOwnedCollections
	| columnDict connection collectionDescription counter |
	columnDict := Dictionary new.
	connection := self currentObject sqSaveConnection.
	self currentObject indirectlyReferencedObjects
		do: [:reference | 
			collectionDescription := reference at: #description.
			counter := 1.
			(reference at: #collection)
				do: [:obj | 
					columnDict := Dictionary new.
					columnDict
						at: collectionDescription referenceColumn columnName
						put: (self valueForObject: obj ofCollectionDescribedBy: collectionDescription).
					columnDict at: collectionDescription ownerColumn columnName put: self currentObject oid.
					
					collectionDescription maintainOrder
						ifTrue: [columnDict at: connection class collectionOrderField put: counter].
					counter := counter + 1.
					connection storeColumns: columnDict inTable: collectionDescription joinTableName
		]
	]! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 11:10'!
instVarsForClassTable
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
loadProxiedObjectOfVariable: ivarName 
	| descr connection collectionElements |
	descr := self currentObject descriptionHandler columnDescriptionFor: ivarName.
	connection := self currentObject sqSaveConnection.
	collectionElements := connection 
		getCollectionDescribedBy: descr
		forObjectId: self currentObject oid.
	^ descr collectionClass withAll: collectionElements! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/29/2008 15:41'!
storeCollectionChanges: changesDictionary withDescription: aDescription
	| connection oid |
	connection := self currentObject sqSaveConnection.
	oid := self currentObject oid.
	(changesDictionary at: #deleted) ifNotEmpty: [
		connection removeEntries: (changesDictionary at: #deleted) fromJoinTable: aDescription forOwnerId: oid.
	].

	"only move the Entries if the order is important"
	(((changesDictionary at: #moved) isEmpty not) and: [aDescription maintainOrder]) ifTrue: [
		connection moveEntries: (changesDictionary at: #moved) inJoinTable: aDescription forOwnerId: oid.	
	].

	(changesDictionary at: #added) ifNotEmpty: [
		connection addEntries: (changesDictionary at: #added) inJoinTable: aDescription forOwnerId: oid.	
	].

! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 16:24'!
structureSpecificChangedColumns
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:06'!
tableCacheForClass: aClass
	TableCache at: aClass name ifAbsentPut: [Dictionary new].
	^TableCache at: aClass name! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 14:59'!
updateObject
	| columnDicts connection |
	"store all directly associated objects right now"
	self currentObject directlyReferencedObjects do: [:obj | obj save].
	
	columnDicts := self createColumnDictionaries.
	connection := self currentObject sqSaveConnection.
	columnDicts do: 
		[ :columnDict | 
		connection inTransactionDo: 
			[ connection 
				updateFields: (columnDict at: #columns)
				ofObjectWithId: self currentObject oid
				inTable: (columnDict at: #tableName) ] ].
		
	self updateOwnedCollections.
	
	! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:20'!
updateOwnedCollections
	| proxy oldCollection tmpProxy colChanges |
	self currentObject indirectlyReferencedObjects do: 
		[ :reference | 
		"this object should always be an SqSaveCollectionProxy that 
		knows how the object looked like at the last save"
		proxy := reference at: #collection.
		proxy do: [ :collectionObj | collectionObj ifNotNil: [ collectionObj save ] ].
		"someone replaced the former collection with an entirely new one"
		proxy class = SqSCollectionProxy ifFalse: 
			[ oldCollection := self loadProxiedObjectOfVariable: (reference at: #variable).
			tmpProxy := SqSCollectionProxy 
				for: oldCollection
				ofInstVar: (reference at: #variable)
				in: self currentObject.
			tmpProxy proxiedObject: proxy.
			proxy := tmpProxy ].
		colChanges := proxy getCollectionChanges.
		self 
			storeCollectionChanges: colChanges
			withDescription: (reference at: #description) ]! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/12/2008 18:20'!
updateTableStructure
	| structureChanges connection |

	structureChanges := self getChangedColumns.
	connection := self currentObject sqSaveConnection.
	"first rename the columns that need renaming"
	connection
		renameColumns: (structureChanges at: #renamed).
	"then alter the ones that need to be altered (sql whise)"
	connection
		alterColumns: (structureChanges at: #altered).
	"delete..."
	connection
		removeColumns: (structureChanges at: #deleted).
	"add..."
	connection
		addColumns: (structureChanges at: #added)! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/15/2008 16:02'!
valueForObject: anObject ofCollectionDescribedBy: collectionDescription
	| sqsObject connection objectValue |
	sqsObject := SqSBase for: anObject.
	connection := sqsObject sqSaveConnection.
	"return the object itself if it is a simple one
	or the oid on complex objects"
	collectionDescription simpleValues ifTrue: [
		objectValue := anObject	
	] ifFalse: [
		anObject ifNil: [
			objectValue := connection class nilValue
		] ifNotNil: [
			sqsObject save.
			objectValue := sqsObject oid
		].
	].
	^objectValue
	! !

Object subclass: #SqSUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSUtil class methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:34'!
doesNotUnderstand: aMessage
	| selector all attributes finderMethod startWord |
	selector := aMessage selector.
	finderMethod := selector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := selector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		all ifTrue:[startWord := 'findAllBy'] ifFalse: [startWord := 'findBy'].
		attributes := self findAttributesInSelector: aMessage selector beginWith: startWord.
		attributes ifNil: [
			^super doesNotUnderstand: aMessage.
		] ifNotNil: [
			^self performSearchFor: attributes withValues: (aMessage arguments) andReturnAll: all.
		].
	] ifFalse: [
		^super doesNotUnderstand: aMessage.
	].
	
	
	! !

!SqSUtil class methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:35'!
findAttributesInSelector: aSelector beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements first) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName at: 1 put: ((attrName first) asLowercase).
		(self allInstVarNames includes: attrName) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [
			^nil
		]
	].
	^searchedAttributes! !

!SqSUtil class methodsFor: 'as yet unclassified' stamp: 'tkow 9/3/2008 18:49'!
performSearchFor: instVars withValues: values andReturnAll: aBool 
	| limit results argumentDictionary base |
	aBool
		ifFalse: [limit := 1].
	base := SqSBase for: self new.
	argumentDictionary := base tableStructureHandler buildSearchFor: instVars withValues: values.
	results := base sqSaveConnection
				performSearchForObjectsOfClass: self
				withArguments: argumentDictionary
				andLimit: limit.
	aBool
		ifTrue: [^ results]
		ifFalse: [^ results
				at: 1
				ifAbsent: []]! !

SqSUtil subclass: #SqSaveTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 12:03'!
acceptsLoggingOfCompilation
	^false! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestDate
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_date';
		 sqlType: 'DATE';
		 objectClass: #Date;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestInteger
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_integer';
		 sqlType: 'SMALLINT';
		 objectClass: #SmallInteger;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestSomething
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_something';
		 sqlType: 'FLOAT';
		 objectClass: #Float;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestString
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_string';
		 sqlType: 'VARCHAR(254)';
		 objectClass: #ByteString;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
tableInheritance
	^ #singleTableInheritance! !

!SqSaveTestObject class methodsFor: 'as yet unclassified' stamp: ''!
wantsChangeSetLogging
	^ false! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate
	^ testDate! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

SqSaveTestObject subclass: #SqSaveTestObjectChild
	instanceVariableNames: 'testSubString testUnstoredVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObjectChild class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestSubString
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_sub_string';
		 sqlType: 'VARCHAR(254)';
		 objectClass: #ByteString;
		 tableName: 'sq_save_test_object_childs';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObjectChild class methodsFor: 'magritte-description' stamp: ''!
sqSaveUnpersistedInstVars
	^ #('testUnstoredVariable' )! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

SqSaveTestObjectChild subclass: #SqSaveTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObjectEvenDeeperChild class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestExtremelyDeepSubString
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_extremely_deep_sub_string';
		 sqlType: 'VARCHAR(254)';
		 objectClass: #ByteString;
		 tableName: 'sq_save_test_object_even_deeper_childs';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

WAComponent subclass: #SqSaveTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps'!

!SqSaveTestComponent class methodsFor: 'as yet unclassified' stamp: 'tk 4/29/2008 15:44'!
canBeRoot
	^true! !

!SqSaveTestComponent methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 17:53'!
renderContentOn: html 
	html anchor
		callback: [ self call: SqSaveTestObject new asComponent addValidatedForm ];
		with: 'new'! !

!Number methodsFor: '*sqsave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionClass
	^#MANumberDescription! !

!Number methodsFor: '*sqsave' stamp: 'tk 5/21/2008 11:10'!
magritteDescriptionDefaultValue
	^'0'! !

!Number methodsFor: '*sqsave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionStandardValue
	^0! !

!Date methodsFor: '*sqsave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionClass
	^#MADateDescription! !

!Date methodsFor: '*sqsave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionDefaultValue
	^'Date today'! !

!Dictionary methodsFor: '*sqsave' stamp: 'tkow 9/12/2008 17:10'!
keysSelect: aBlock
	| newCollection |

	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each key) ifTrue: [newCollection add: each]].
	^newCollection! !

!Dictionary methodsFor: '*sqsave' stamp: 'tk 8/15/2008 14:55'!
valueJoin: anotherDictionary
	"really joins two dictionaries with collections as values"
	| ownValue mergeValue |
	anotherDictionary associationsDo: [ :assoc |
		(self includesKey: assoc key) ifTrue: [
			ownValue := (self at: assoc key) isCollection ifTrue:[
				self at: assoc key
			] ifFalse: [
				OrderedCollection with: (self at: assoc key)
			].
			mergeValue := (assoc value) isCollection ifTrue:[
				assoc value
			] ifFalse: [
				OrderedCollection with: (assoc value).
			].
			self at: assoc key put: (ownValue union: mergeValue).
		] ifFalse: [
			self at: assoc key put: assoc value
		]
	].
	^self! !
